#!/usr/bin/env python3
# creates PAGES and WORDS for the prgram search.js
# Scans the website and collects words

import sys,os
from bs4 import BeautifulSoup
from subprocess import Popen, PIPE
import re
from unidecode import unidecode
parser   = 'html5lib'
encoding = "utf8"

indir   = "/home/willem/public_html/websites/easyhosting/httpdocs/ratrabbit"
outfile = "search/searchdata.js"

def eprint(*args, **kwargs):
    print(*args, file=sys.stderr, **kwargs)

def extract(fname):
    with open(fname) as fp:
        soup = BeautifulSoup(fp, parser)

    title = soup.find('title').string.replace('\n',' ')
    title = re.sub(r'RatrabbiT-','',title)

    content = soup.find('div',id='content')
    #content = soup.find('body')
    if not content:
        return
    string = ""
    for x in content.strings:
        string += str(x)

    #string = re.sub(r'[^ \w+]', '', string).lower()
    string = unidecode(re.sub(r'[^\w]',' ', string).lower())

    return title, sorted(set(string.split()))


out = open(outfile,"w")
files = []
os.chdir(indir)
for (root,dirs,fils) in os.walk('.', topdown=True):
    if root == "./user":
        continue
    for f in fils:
        if f[-5:] == '.html':
            files += [root+"/"+f]

#for f in files:
#    print(f)
words = {}
pages = []
id    = 0
for f in files:
    print ("Looking at:",f)
    extraction = extract(f)
    if not extraction:
        continue
    title, w = extraction
    pages += [[f,title]]
    for item in w:
        if words.get(item):
            words[item] += [id]
        else:
            words[item] = [id]
    id += 1

#eprint("pages:",pages)
#eprint("words:",words)

#print("const pages = ",repr(pages).replace("[","\n["),";")
#print("const words = ",repr(words).replace(", '",",\n'"),";")


out.write("const PAGES =[\n")
for p in pages:
    out.write(repr(p)+",\n")
out.write("];\n")

out.write("const WORDS ={\n")
for w in words:
    out.write(repr(w)+" : "+repr(words[w])+",\n")
out.write("};\n")

out.close()
print("Proper usage: wdcms && ./mkindex.py && wdcms")

