"use strict";
const programid = "Willem's tennis scheduler";

const VERSION = "2.2";
const DOPRINT = true; // if true: print() replaces console.log(), else print() does nothing

// https://stackoverflow.com/questions/610406/javascript-equivalent-to-printf-string-format
String.prototype.fmt = String.prototype.fmt ||
   function() {
      "use strict";
      var str = this.toString();
      if (arguments.length) {
         var t = typeof arguments[0];
         var key;
         var args = ("string" === t || "number" === t) ?
            Array.prototype.slice.call(arguments) :
            arguments[0];
         for (key in args) {
            str = str.replace(new RegExp("\\{" + key + "\\}", "gi"), args[key]);
         }
      }
      return str;
   };

$(document).ready(function() {

   function do_debug() {
      return;
      print("version:", versiondate, versionrev);
      print("oldversion:", oldversiondate, oldversionrev);
      print("dataversion:", data.version.date, data.version.rev);
      print("resultversion:", data.version.date, data.version.rev);
      print("resultversion:", resultversion, "data.resultversion:", data.resultversion);
      print("ndplayers players need_apply:", ndplayers, nplayers, need_apply);
      return;
      create_dates();
      print("lang", navigator.languages, lang);
      console.log('<!DOCTYPE html>\n<html>\n' + $("html").html() + '\n</html>');

      // todo
      $('#menu').toggleClass("sticky");
      $('#menu_container').toggleClass("sticky");
      return;
      debugger;
      print("version:", versiondate, versionrev);
      print("oldversion:", oldversiondate, oldversionrev);
      print("dataversion:", data.version.date, data.version.rev);
      print("crc:", crc == data2crc());

      return;
   }
   // https://stackoverflow.com/questions/4946287/finding-out-if-console-is-available
   // https://stackoverflow.com/questions/13815640/a-proper-wrapper-for-console-log-with-correct-line-number

   let print;
   if (typeof(console) == 'object' && typeof(console.log) == 'function')
      print = console.log.bind(console);
   else
      print = function() {};
   if (!DOPRINT)
      print = function() {};


   print("Willem's multi scheduler");

   // example of data: see function init_data



   // globals used at the computations:
   //  Partly, these are copies of the value in the 'data' struct
   //  In this way, the code is more tranportable, hopefully
   //
   let avail = []; //(0..1)        V   matrix with availabilities
   let avoids = []; //       V   these players not in one team
   let dates = []; //        V   array with dates
   let daypayers = 1; //     V   number of payers of drinks per day
   let fiddle = 1; //            start of random generator
   let forces = []; //       V   players forced in team
   let gender = []; //       V   gender of players 0-male, 1=female
   let isfreeday = []; //    V   indices of the freedays (0..)
   let maketeams = true; //  V   use teams or not
   let maxndplayers = 20; //    Maximum number of players per day
   let ndates = 0; //        V   number of dates
   let nforces = 0; //       V   number of forces
   let nplayers = 0; //      V   number of players
   let ndplayers = 0; //      V   number of players/day
   let nrplayers = 0; //     V   number of rplayers
   let nvetos = 0; //        V   number of vetos
   let persons = {}; // known persons
   let players = []; //      V   nicknames of players
   let rplayers = []; //     V   reserve players
   let strength = []; //     V   strengths of players
   let varia = ""; //        V   random text
   let versiondate, versionrev;
   let resultversion = "0";
   let vetos = []; //        V   forbid to play
   let game_type = '';
   let playing_days = [];
   // end of globals
   //
   // these are dependent on globals and must be adapted whenever globals is changed
   let pl2num = {}; //       V   player to number conversion
   let da2num = {}; //       V   date to number conversion
   // end

   let ngen = 4000; //          V   number of generations
   let npop = 50; //          V   number of populations
   let startdate = date2iso(new Date);
   let enddate = startdate;
   enddate = next_date(startdate, 42);
   let pop = []; // populations
   let foms = []; // foms of populations
   let result = []; // solution
   let meet = []; // meeting table
   let maxfree = []; //          for each player, the maximum non-playing days in a row
   let freedays = {};
   let sumavail = []; // (int) total number of possible games per player
   let scrolltop; // to remember the position of the window
   let hscrolltop; // idem for help window
   let data = {};
   let table;
   let filename = "";
   let filecontent = "";
   let oldversiondate, oldversionrev;
   let fomevals = 0;
   let need_apply = false;
   let in_addplayer = false;
   let crc; // some time ago this was the crc of data, but now it is data itself
   let gettext;
   let lang = 'en';
   let _;
   let languages = [];

   //const npopbutton = '<input id="npop" type="number" min="1" max="99999" size="4"/>';
   //const ngenbutton = '<input id="ngen" type="number" min="1" max="99999" size="4"/>';
   let plusbutton;
   let minbutton;
   let plusplayer;
   let plusplayer1;
   let plusrplayer;
   let plusrplayer1;
   let minplayer;
   let minrplayer;
   let downloadbutton;
   let uploadbutton;
   let printbutton;
   let examplebutton;
   let emptybutton;
   let manualbutton;
   let playersbutton;
   let teamsbutton;
   let payersbutton;
   let fiddlebutton;
   let applybutton;
   let toemailsbutton;
   let tovariabutton;
   let toschemebutton;
   let toavoidsbutton;
   let toreservebutton;
   let language_buttons;
   let plusplayerth;
   let plusrplayerth;

   let snames;
   let gnames;
   let longgnames;
   let open_text;
   let store_text;
   let computed_text;
   let print_pdf_text;
   let help_text;
   let example_text;
   let teams_text;
   let playing_dates_text;
   let players_max_day_text;
   let drinks_per_day_text;
   let yes_text;
   let no_text;
   let no_play_day_text;
   let plays_in_team_text;
   let plays_text;
   let free_text;
   let reserve_player_text;
   let add_text;
   let add_player_text;
   let add_players_text;
   let add_rplayer_text;
   let add_rplayers_text;
   let fill_in_schedule;
   let process_text;
   let start_date_text;
   let last_date_text;
   let game_text;
   let new_schedule_text;
   let naw_text;
   let varia_text;
   let weekdays;
   let shortdays;

   // w.play w.free w.even w.meet w.gender
   let weights = [4, 8, 2, 1, 1];
   gettext = (window.i18n)();
   _ = gettext.gettext.bind(gettext);


   const FREE = 0;
   const ABSENT = 1;
   const FREEDAY = 2;
   const PLAYING = 3;
   const FORCEDFREE = 4;
   const FORCEDTEAM = 5;

   //const FREEDAYTXT = 'ooo';
   //const FREEDAYTXT = '&#9940;&#9940;&#9940;';
   //const FREEDAYTXT = '&#9788;&#9788;&#9788;';
   const FREEDAYTXT = '&#9969;&#9969;&#9969;';
   //const NOTENOUGHTXT = '&#9733;&#9733;&#9733;';
   const NOTENOUGHTXT = '&#9785;&#9785;&#9785;';

   const PLAYTXT = 'X';
   const ABSENTTXT = '-';
   const DRINKTXT = '&euro;';
   //   const NOPLAYTXT = "☂";
   const NOPLAYTXT = "☼";
   //   const NOPLAYTXT = "✫";
   //   const NOPLAYTXT = "≠";
   //   const NOPLAYTXT = "⊝";
   //   const NOPLAYTXT = "⊗";
   //   const NOPLAYTXT = "∅";
   //   const NOPLAYTXT = "⦵";

   const letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

   function define_texts() {
      snames = [_("matig"), _("gemiddeld"), _("sterk")];
      gnames = [_("M"), _("V")];
      longgnames = [_("man"), _("vrouw")];

      open_text = _("Open opgeslagen schema");
      store_text = _("Bewaar dit schema");
      computed_text = _("Berekend");
      print_pdf_text = _("print/pdf");
      help_text = _("Help");
      example_text = _("Voorbeeld");
      teams_text = _("Teams vormen");
      playing_dates_text = _("Speeldata erbij/eraf");
      players_max_day_text = _("Spelers max / dag");
      drinks_per_day_text = _("Drankjes / dag");
      yes_text = _("Ja");
      no_text = _("Nee");
      no_play_day_text = _("geen speeldag");
      plays_in_team_text = _("speelt in team");
      plays_text = _("speelt");
      free_text = _("heeft vrij");
      reserve_player_text = _("Reservespeler(s)");
      add_text = _("Voeg toe");
      add_player_text = _("Voeg speler toe");
      add_players_text = _("Voeg spelers toe");
      add_rplayer_text = _("Voeg reservespeler toe");
      add_rplayers_text = _("Voeg reservespeler(s) toe");
      process_text = _("Verwerk");
      start_date_text = _("Startdatum");
      last_date_text = _("Einddatum");
      game_text = _("Welke sport (Tennis, Padel, ...)");
      new_schedule_text = _("Nieuw schema");
      naw_text = _("NAW"); // name, email etc.
      varia_text = _("Varia");
      weekdays = [_("zondag"), _("maandag"), _("dinsdag"), _("woensdag"), _("donderdag"), _("vrijdag"), _("zaterdag")];
      shortdays = [_('Ma'), _('Di'), _('Wo'), _('Do'), _('Vr'), _('Za'), _('Zo')];
      fill_in_schedule = _("VUL HET SCHEMA IN");
   }

   function define_buttons() {

      //npopbutton = '<input id="npop" type="number" min="1" max="99999" size="4"/>';
      //ngenbutton = '<input id="ngen" type="number" min="1" max="99999" size="4"/>';
      plusbutton = '<button class="adddate">&nbsp;+&nbsp;</button>';
      minbutton = '<button class="deldate">&nbsp;-&nbsp;</button>';
      plusplayer = '<button class="addplayer" id="addplayer">&nbsp;' + add_player_text + '&nbsp;</button>';
      plusplayer1 = '<button id="addplayer1">&nbsp;' + _("Voeg toe") + '&nbsp;</button>';
      plusrplayer = '<button class="addrplayer" id="addrplayer">&nbsp;' + add_rplayer_text + '&nbsp;</button>';
      plusrplayer1 = '<button id="addrplayer1">&nbsp;' + _("Voeg toe") + '&nbsp;</button>';
      minplayer = '<button class="delplayer">&nbsp;-&nbsp;</button>';
      minrplayer = '<button class="delrplayer">&nbsp;-&nbsp;</button>';
      downloadbutton = '<button id="download">&nbsp;' + store_text + '&nbsp;</button>';
      uploadbutton = '<button id="upload">&nbsp;' + open_text + '&nbsp; </button>';
      printbutton = '<button id="print_result">&nbsp;' + print_pdf_text + '&nbsp;</button>';
      examplebutton = '<button class="examplebutton">&nbsp;' + example_text + '&nbsp;</button>';
      emptybutton = '<button class="emptybutton">&nbsp;' + new_schedule_text + '&nbsp;</button>';
      manualbutton = '<button class="manualbutton">&nbsp;' + _("Handleiding") + ' / ' + _("stappenplan") + '&nbsp;</button>';
      playersbutton = '<input id="ndplayers" type="number" min="1" max="20" size="4"/>';
      teamsbutton = '<button id="teams" style="width:4em"> </button>';
      payersbutton = '<input id="daypayers" type="number" min="0" max="20" size="4"/>';
      fiddlebutton = '<input id="fiddle" type="number" min="1" max="9" size="4"/>';
      applybutton = '<button class="apply">' + process_text + '</button>';
      toemailsbutton = '<button class="toemails">' + naw_text + '</button>';
      tovariabutton = '<button class="tovaria">' + varia_text + '</button>';
      toschemebutton = '<button class="toscheme">' + _("Naar het schema") + '</button>';
      toavoidsbutton = '<button class="toavoids">' + _("Niet samen") + '</button>';
      toreservebutton = '<button class="toreserve">' + _("Toon reservespelers") + '</button>';

      plusplayerth = '<th class="plusplayerth noprint">&nbsp;' + plusplayer + '</th>';
      plusrplayerth = '<th class="plusrplayerth noprint">&nbsp;' + plusrplayer + '</th>';

      language_buttons = [];
      for (let l in languages) {
         let ll = languages[l];
         language_buttons[l] = '<button class="lang_' + ll + '">' + ll + '</button>';
      }

   }


   // kind of main

   print("Starting main...");

   print("VERSION:", VERSION);

   define_texts();
   $("body").html(init_body());

   print("Testing random number generator:");
   random.seed = 1; // for random()
   validate_random();

   try {
      lang = navigator.languages[0].substring(0, 2);
   } catch (e) {
      lang = "en";
   }

   languages = [];
   for (let l in window.all_languages) {
      print("getting language:", l);
      gettext.setMessages('messages', l, all_languages[l]);
      languages.push(l);
   }
   languages.sort();
   print("languages:", languages);

   gettext.setLocale(lang);

   print("Calling define_clicks:");
   define_clicks();

   $(window).on('beforeunload', function() {
      if (crc != data2crc()) {
         return _("U hebt uw veranderingen niet opgeslagen") + ".";
         // most browsers fill in own text.
      }
   });

   window.goto = function(x) {
      let element_to_scroll_to = $("#" + x)[0];
      // https://stackoverflow.com/questions/6682451/animate-scroll-to-id-on-page-load
      $("html, body").animate({
         scrollTop: $(element_to_scroll_to).offset().top
      }, 400);
   }


   print("Calling init_table:");
   $('#tstable').html(init_table());
   //print("Calling initrpayers:");
   //initrplayers();
   //print("Calling init_help:");
   //$('#help').html(init_help());
   //print("Calling init_top:");
   //$('#top').html(init_top());
   $("#toptitle").click(function() {
      do_debug();
   });

   // print("Calling initts:");
   //$('#menu').html(initts());

   print("Calling initpicker:");
   initpicker();

   print("Calling initplayers:");
   initplayers();

   print("Calling init_data: Define start data");
   data = init_data();
   data = empty_data();

   print("Calling data2globals:");
   data2globals();
   print("Calling quick_solution: create a crude solution");
   quick_solution();
   print("Calling globals2screen:");
   globals2screen();
   goto('startofpage');

   crc = data2crc();


   needupdate(0);

   $('#help').hide();
   $('#menu').show();
   $('#tstable').show();

   //function _(x) {
   //   return x;
   // }

   function handle_apply() {
      print("forces:");
      print_forces();
      print("vetos:");
      print_vetos();
      print("avoids:");
      print_avoids();
      scrolltop = $(window).scrollTop();
      $("#table").addClass("computing");
      $(".applywarning").hide();
      npop = 8 * ndates;
      if (npop < 100) npop = 100;
      ngen = 40 * npop;
      setTimeout(function() {
            compute_result();
            $("#table").removeClass("computing");
            globals2screen();
         },
         100);
   }

   function define_clicks() {

      $(document).on('click', '.toemails', function() {
         goto('emailsjump');
      });

      $(document).on('click', '.tovaria', function() {
         goto('variajump');
      });

      $(document).on('click', '.toavoids', function() {
         goto('avoids');
      });

      $(document).on('click', '.toscheme', function() {
         goto('schemejump');
      });

      $(document).on('click', '.toreserve', function() {
         goto('reservejump');
      });

      $(document).on('click', '#freedayinfo', function() {
         alert("Klik op een datum om vrije dag aan of uit te zetten.");
      });

      $(document).on('mousedown', '.apply', function(e) {
         if (e.buttons != 1)
            return;
         handle_apply();
      });


      $(document).on('keyup', '.hplayer', function() {
         if (nplayers < ndplayers)
            return;
         $(".applywarning").show();
         $('.apply').addClass('need_apply');
      });

      $(document).on('keyup paste', '.name,.email,.phone', function() {
         let element = this;
         setTimeout(function() {
            let [i, j, emailbody] = coords_of_cell($(element));
            let p = cell_with_coords(emailbody, i, 0).text().toLowerCase().trim();
            let val = $(element).val();
            switch (j) {
               case 1:
                  persons[p].name = val;
                  break;
               case 2:
                  persons[p].email = val;
                  break;
               case 3:
                  persons[p].phone = val;
                  break;
            }
         }, 100);
      });


      $(document).on('keyup paste', '#varia', function() {
         let element = this;
         setTimeout(function() {
            varia = $(element).val();
         }, 100);
      });

      $(document).on('keyup paste', '#gametype', function() {
         let element = this;
         setTimeout(function() {
            game_type = $(element).val();
            $(".game").text("").text(game_type);
         }, 100);
      });

      $(document).on('click', '.strength', function() {
         return;
         let val = Math.floor(Number($(this).text()));
         if (val <= 1)
            val = 1;
         val++;
         if (val > 3)
            val = 1;
         $(this).text(val);
         let [i, j, emailbody] = coords_of_cell($(this));
         let p = cell_with_coords(emailbody, i, 0).text().toLowerCase();
         persons[p].strength = val;
         etc2globals();
         quick_solution();
      });

      $(document).on('click', '.gender', function() {
         return;
         let val = $(this).text();
         if (val == 'M')
            val = 'V';
         else
            val = 'M';

         let [i, j, emailbody] = coords_of_cell($(this));
         let p = cell_with_coords(emailbody, i, 0).text().toLowerCase();
         if (val == 'V')
            persons[p].gender = 0;
         else
            persons[p].gender = 1;
         etc2globals();
         quick_solution();
      });

      $(document).on('click', '#addplayer1', function(e) {
         $('#plusplayerspan').html('<input id="playerinput" class="hplayer" type="text" placeholder="' + _("voornaam speler") + '">');
         $('#playerinput').focus();

      });
      $(document).on('click', '#addrplayer1', function(e) {
         $('#plusrplayerspan').html('<input id="rplayerinput" class="rplayer" type="text" placeholder="' + _("voornaam reserve speler") + '">');
         $('#rplayerinput').focus();
      });
      $(document).on('click', '#rplayerinput,#playerinput', function() {
         globals2screen();
      });

      $(document).on('mousedown', '.addplayer', function(e) {
         if (e.buttons != 1)
            return;
         setTimeout(function() {
            etc2globals(); // this first, to prevent need_apply warning if player is still blank
            let p = "";
            players.push(p);
            quick_solution();
            $(".plusplayerth").hide();
            $('input.hplayer[value="' + p + '"]').focus();
         }, 100);
      });

      $(document).on('mousedown', '.addrplayer', function(e) {
         if (e.buttons != 1)
            return;
         setTimeout(function() {
            scrolltop = $(window).scrollTop();
            let p = "";
            rplayers.push(p);
            etc2globals();
            globals2screen();
            $(".plusrplayerth").hide();
            $('input.rplayer[value="' + p + '"]').focus();
         }, 100);
      });


      $(document).on('click', ".adddate", function() {
         adddate();
      });

      $(document).on('click', ".deldate", function() {
         deldate();
      });


      $(document).on('input', '.hplayer', function() {
         adaptsize($(this));
         //$(".addplayer").hide();
         $(".addplayer").attr("disabled", "true");
      });

      $(document).on('input', '.rplayer', function() {
         adaptsize($(this));
         //$(".addrplayer").hide();
         $(".addrplayer").attr("disabled", "true");
      });


      $(document).on('click', '.delplayer', function() {
         let n = $(this).closest('th').index() - 1;
         delete players[n];
         etc2globals();
         quick_solution();
      });

      $(document).on('click', '.delrplayer', function() {
         scrolltop = $(window).scrollTop();
         let n = $(this).closest('th').index() - 1;
         delete rplayers[n];
         etc2globals();
         globals2screen();
      });

      $(document).on('click', '#download', function() {
         download();
      });

      $(document).on('click', '#upload', function() {
         upload();
      });

      $(document).on('click', '#print_result', function() {
         print_result();
      });

      $(document).on('click', '.manualbutton', function() {
         scrolltop = $(window).scrollTop();
         $('#tstable,#menu,#version').fadeOut(400);
         setTimeout(function() {
            $('#help').fadeIn(400);
            setTimeout(function() {
               $(window).scrollTop(hscrolltop);
            }, 100);
         }, 400);

         function show_totopbutton() {
            if ($(window).scrollTop() > 100)
               $('#totopbutton').fadeIn(400);
            else
               $('#totopbutton').fadeOut(400);
         }
         window.onscroll = show_totopbutton;
         show_totopbutton();
      });

      $(document).on('click', '#leavemenubutton', function() {
         hscrolltop = $(window).scrollTop();
         $('#help').fadeOut(400);
         setTimeout(function() {
            $('#menu,#tstable,#version').fadeIn(400);
            setTimeout(function() {
               $(window).scrollTop(scrolltop);
            }, 100);
         }, 400);
         window.onscroll = null;
      });

      $(document).on('click', '#totopbutton', function() {
         //document.body.scrollTop = 0; // For Safari
         //document.documentElement.scrollTop = 0; // For Chrome, Firefox, IE and Opera
         $("html, body").animate({
            scrollTop: 0
         }, 400);
      });

      $(document).on('click', '#teams', function() {
         if (maketeams == 0) {
            maketeams = 1;
            $(this).text(yes_text);
         } else {
            maketeams = 0;
            $(this).text(no_text);
         }
         etc2globals();
         quick_solution();
      });

      $(document).on('change', '#npop', function() {
         npop = Number($(this).val());
      });

      $(document).on('change', '#ngen', function() {
         ngen = Number($(this).val());
      })

      $(document).on('click', '#tavoids .avoidcell', function() {
         let [i, j, dummy] = coords_of_cell($(this));
         j = j - 1;
         if (i == j) return;
         let p = players[i];
         let q = players[j];
         if (persons[p].avoid[q] || persons[q].avoid[p]) {
            delete persons[p].avoid[q];
            delete persons[q].avoid[p];
         } else {
            persons[p].avoid[q] = 1;
            persons[q].avoid[p] = 1;
         }
         etc2globals();
         quick_solution();
      });

      $(document).on('click', '#table .rowdate', function() {
         //var d = $(this).text();
         let [i, j, dummy] = coords_of_cell($(this));
         let d = dates[i];
         if (freedays[d])
            delete freedays[d];
         else
            freedays[d] = 1;
         etc2globals();
         quick_solution();
      });

      $(document).on('change', '.hplayer', function() {
         let n = $(this).closest('th').index() - 1;
         players[n] = $(this).val();
         etc2globals();
         quick_solution();
      });

      $(document).on('change', '.rplayer', function() {
         let n = $(this).closest('th').index() - 1;
         rplayers[n] = $(this).val();
         etc2globals();
         scrolltop = $(window).scrollTop();
         globals2screen();
      });

      $(document).on('change', '#ndplayers', function() {
         let v = $(this).val();
         ndplayers = get_int(v, 4);
         etc2globals(); // will take care of allowed values
         quick_solution();
      });

      $(document).on('change', '#daypayers', function() {
         let v = $(this).val();
         daypayers = get_int(v, 1);
         if (false) {
            if (v && v >= 0)
               daypayers = Number(v);
            else {
               daypayers = 1;
               $(this).val(daypayers);
            }
            if (daypayers > ndplayers) {
               daypayers = ndplayers;
               $('#daypayers').val(daypayers);
            }
         }
         etc2globals();
         globals2screen();
         //quick_solution();
      });

      $(document).on('change', '#fiddle', function() {
         let v = Number($(this).val());
         if (v && v >= 0) {
            fiddle = v;
            etc2globals();
            quick_solution();
         }
      });

      //$(document).on('keydown', '#ndplayers,#daypayers,#firstdate,#fiddle', function() {
      $(document).on('keydown', '#firstdate,#fiddle', function() {
         return false;
      });

      $(document).on('change', '#uploadinput', function(evt) {
         if (!window.FileReader) {
            return; // Browser is not compatible
         }

         filename = evt.target.files[0].name;

         var reader = new FileReader();

         reader.onload = function(evt) {
            if (evt.target.readyState != 2) return;
            if (evt.target.error) {
               alert('Error while reading file');
               return;
            }

            filecontent = evt.target.result;
            try {
               data = JSON.parse(filecontent);
            } catch (e) {
               jsonerror();
               return;
            }
            data2globals();
            if (!data.programid || data.programid != programid) {
               jsonerror();
               return;
            }
            globals2screen();

            $('#text').val(filecontent); //no-op, can be used for debugging

         };

         reader.readAsText(evt.target.files[0]);
      });

      $(document).on('click', '.examplebutton', function() {
         if (crc != data2crc()) {
            let rc = confirm(_("U hebt deze sessie nog niet opgeslagen. Toch doorgaan met openen van het voorbeeld?"));
            if (!rc)
               return;
         }
         data = init_data();
         print("Calling data2globals:");
         data2globals();
         if (false) {
            print("Calling compute_result");
            compute_result();
            print("Calling globals2screen:");
            globals2screen();
            crc = data2crc();
         } else {
            handle_apply();
            setTimeout(function() {
               crc = data2crc();
            }, 120);
         }
      });

      $(document).on('click', '.emptybutton', function() {
         if (crc != data2crc()) {
            let rc = confirm(_("U hebt deze sessie nog niet opgeslagen. Toch doorgaan met openen van een leeg schema?"));
            if (!rc)
               return;
         }
         data = empty_data();
         print("Calling data2globals:");
         data2globals();
         print("Calling quick_solution: create a crude solution");
         quick_solution();
         print("Calling globals2screen:");
         globals2screen();

         crc = data2crc();
      });

      $(document).on('click', '.tableclick', handle_tableclick);

      for (let l in languages) {
         let ll = languages[l];
         let c = '.lang_' + ll;
         $(document).on('click', c, function() {
            lang = ll;
            scrolltop = $(window).scrollTop();
            globals2screen();
         });
      };

      $(document).on('click', '.strengthclick', handle_strengthclick);
      $(document).on('click', '.genderclick', handle_genderclick);
      $(document).on('click', '.avoidsclick', handle_avoidsclick);

      for (let i = 0; i < 7; i++) {
         let c = '.weekday' + i;
         $(document).on('click', c, function() {
            $(c).toggleClass('clicked');
            playing_days = [];
            for (let i = 0; i < 7; i++) {
               if ($('.weekday' + i).hasClass('clicked')) {
                  playing_days.push(i);
               }
            }
            etc2globals();
            quick_solution();
         });
      }

   } // end define_clicks()

   function empty_data() {
      let d = {};
      d.programid = programid;
      d.players = [];
      d.rplayers = [];
      d.persons = {};
      d.ndates = 7;
      d.nplayers = 0;
      d.ndplayers = 4;
      d.daypayers = 1;
      d.fiddle = 1;
      d.maketeams = 1;
      d.freedays = {};
      d.startdate = date2iso(new Date); // today
      d.gametype = "";
      return d;
   }

   function version_text() {
      return '<span id="version">' +
         '<b>' +
         '<span class="game"></span> ' + _("schema") + " " + _(date2weekday(startdate, false)) +
         '&nbsp;' + dates[0] + " " + _("t/m") + " " + dates[ndates - 1] +
         '</b>' +
         "&nbsp;" + _("versie") +
         '&nbsp;<span id="versiondate"></span>.<span id=versionrev></span></span>\n';
   }

   function init_lang() {
      // handle language
      gettext.setLocale(lang);
   }

   function init_body() {
      return '' +
         apply_warning() +
         '<div id="top">\n' +
         '  <h1 id="toptitle">Willem\'s game scheduler</h1>\n' +
         '</div>\n' +
         '<div id="menu_container">\n' +
         '   <div id="menu">\n' +
         '   </div>\n' +
         '</div>\n' +
         '<div id="tstable">\n' +
         '</div>\n' +
         '<div id="help">\n' +
         '</div>\n'
   }

   function init_top() {
      let t = '\n';
      //t += apply_warning();
      t += '<div id="startofpage"></div>\n'
      t += '<div id="topdiv" style="width: 40em; margin:auto; text-align: center; cursor: default;">\n';
      t += '   <span class="noprint">\n';
      t += '      <span id="toptitle" style="font-size:larger;" class="noinput">Willem\'s multi scheduler</span>\n';
      t += '      <span style="font-size:smaller;">' + VERSION + '</span>\n';
      t += '      <span id="languagebuttons">\n';
      for (let l in languages) {
         t += '      ' + language_buttons[l] + '\n';
      }
      t += '      </span>\n';
      t += '      <br>\n';
      t += '   </span>\n';
      t += '   <br>\n';
      t += '   ' + version_text() + '\n';
      t += '</div>\n';
      t += '<br>\n';

      return t;
   }

   function week_day_buttons() {
      let r = "";
      for (let d = 0; d < 7; d++) {
         r += '<button class="weekday' + d + '">' + shortdays[d] + '</button>';
      }
      return r;
   }

   function initts() {
      let now = new Date();
      let nowstr = date2iso(now);
      let fdate = next_date(nowstr, 7);
      let ldate = enddate;

      let page = '' +
         '<table id="exampletable" class="noprint">\n' +
         '   <tbody>\n' +
         '      <tr><td></td><td>' + manualbutton + '</td><td></td></tr>\n' +
         '      <tr>\n' +
         '          <td>' + examplebutton + '</td>\n' +
         '          <td></td>\n' +
         '          <td>' + emptybutton + '</td>\n' +
         '      </tr>\n' +
         '   </tbody>\n' +
         '</table>\n' +
         '<br class="noprint">\n' +
         '<table id="legendatable">\n' + // table with only one cell
         '   <tr>\n' +
         '      <td class="noborder" id="onlycell">\n' +
         '          <table id="innerlegendatable" style="margin-left:0;">\n' +
         '             <tr>\n' +
         '                <td><span class="legendaspan"><b>' + _("LEGENDA") + '</b></span></td>\n' +
         '                <td>&nbsp;</td>\n' +
         '                <td class="freeday noprint" id="freedayinfo">&nbsp;' + capitalize(no_play_day_text) + '&nbsp;</td>\n' +
         '                <td>&nbsp;</td>\n' +
         '                <td class="absent noprint">&nbsp;' + _("Door u aangepast") + '&nbsp;</td>\n' +
         '                <td>&nbsp;</td>\n';
      if (need_apply) page +=
         '                <td class="to_compute noprint">&nbsp;' + computed_text + '&nbsp;</td>\n';
      else page +=
         '                <td  class="computed noprint">&nbsp;' + computed_text + '&nbsp;</td>\n';
      page +=
         '             </tr>\n' +
         '          </table>\n' +
         '          <br class="noprint">\n' +
         '          <table style="text-align:left;">\n' +
         '             <tr>\n' +
         '                <td style="width:4em"></td>\n' +
         '                <td style="text-align:right;">&nbsp; <span id="playcode">' + PLAYTXT + '</span></td>\n' +
         '                <td>:&nbsp;</td>\n' +
         '                <td><span id="plays">' + plays_text + '</span></td>\n' +
         '                <td>&nbsp;</td>\n';
      if (daypayers > 0) page +=
         '                <td style="text-align:right;">&nbsp; ' + DRINKTXT + '</td>\n' +
         '                <td>:&nbsp;</td>\n' +
         '                <td>&nbsp;' + _("betaalt drankje") + '&nbsp;</td>\n';
      page +=
         '             </tr>\n' +
         '             <tr>\n' +
         '                <td></td>' +
         '                <td style="text-align:right;">&nbsp;' + ABSENTTXT + '</td>\n' +
         '                <td>:&nbsp;</td>\n' +
         '                <td>' + _("is verhinderd") + '</td>\n' +
         '                <td>&nbsp;</td>\n';
      if (_(NOPLAYTXT).trim().length == 0) page +=
         '                <td style="text-align:right;">&nbsp; ' + _("blanco") + '</td>\n';
      else page +=
         '                <td style="text-align:right;">&nbsp; ' + _(NOPLAYTXT) + '</td>\n';
      page +=
         '                <td>:&nbsp;</td>\n' +
         '                <td>&nbsp;' + free_text + '&nbsp;</td>\n' +
         '             </tr>\n' +
         '             <tr>\n' +
         '                <td></td>\n' +
         '                <td style="text-align:right;">&nbsp;' + NOTENOUGHTXT + '</td>\n' +
         '                <td>:&nbsp;</td>\n' +
         '                <td>' + _("te weinig spelers beschikbaar") + '</td>\n' +
         '                <td>&nbsp;</td>\n' +
         '                <td style="text-align:right;">&nbsp; ' + FREEDAYTXT + '</td>\n' +
         '                <td>:&nbsp;</td>\n' +
         '                <td>&nbsp;' + no_play_day_text + '&nbsp;</td>\n' +
         '             </tr>\n' +
         '          </table>\n' +
         '      </td>\n' +
         '   </tr>\n' +
         '</table>\n' +
         '<br>\n' +
         '<table id="yourscheme" class="noprint">\n' +
         '   <tr>' +
         '      <td><b>' + _("UW SCHEMA") + '</br></td>\n' +
         '      <td>&nbsp;</td>' +
         '      <td>' + toschemebutton + '</td>\n' +
         '      <td>&nbsp;</td>' +
         '      <td>' + downloadbutton + '</td>\n' +
         '      <td>&nbsp;</td>' +
         '      <td>' + uploadbutton + '</td>\n' +
         '      <td>&nbsp;</td>' +
         '      <td>' + printbutton + '</td>\n' +
         '   </tr>\n' +
         '</table>\n' +
         '<br class="noprint">\n' +
         '<table id="fillin" class="noprint">\n' +
         '   <tr>\n' +
         '      <td><b>' + fill_in_schedule + '</b></td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '   <tr>\n' +
         '      <td>&nbsp;' + game_text + ':</td>\n' +
         '      <td></td>\n' +
         '      <td>\n' +
         '         <input type="text" id="gametype" value="' + game_type + '">\n' +
         '      </td>\n' +
         '   </tr>\n' +

         '      <td>&nbsp;' + start_date_text + ' / ' + _("Speeldagen") + ':&nbsp</td>\n' +
         '      <td class="weekday-show">aap</td>\n' +
         '      <td>\n' +
         '         <input type="text" id="firstdate" value="' + fdate + '" autocomplete="off">\n' +
         '      </td>\n' +
         '      <td>\n' +
         week_day_buttons() +
         '      </td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '      <td>&nbsp;' + last_date_text + '</td>\n' +
         '      <td></td>\n' +
         '      <td>\n' +
         '         <input type="text" id="lastdate" value="' + ldate + '" autocomplete="off">\n' +
         '      </td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '      <td>&nbsp;' + players_max_day_text + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td>' + playersbutton + '</td>\n' +
         '   </tr>\n' +
         '   <tr>' +
         '      <td style="text-align:left;">&nbsp;' + teams_text + ':&nbsp;</td>' +
         '      <td></td>\n' +
         '      <td>' + teamsbutton + '</td>' +
         '   </tr>\n' +
         '   <tr>' +
         '      <td>&nbsp;' + drinks_per_day_text + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td>' + payersbutton + '</td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '      <td>&nbsp;' + _("Voeg spelers toe") + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td><span id="plusplayerspan">' + plusplayer1 + '</span></td>\n' +
         '      <td>' + _("Plaats <b>alle</b> spelers in het schema") + '</td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '       <td><b>&nbsp;' + _("Het volgende is optioneel") + ':</b></td>\n' +
         '   </tr>\n' +
         '   <tr>\n' +
         '      <td>&nbsp;' + add_rplayers_text + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td><span id="plusrplayerspan">' + plusrplayer1 + '</span></td>\n' +
         '      <td>' + toreservebutton + '</td>\n' +
         '   </tr>\n';
      if (nplayers + nrplayers > 0) page +=
         '   <tr>' +
         '      <td>&nbsp;' + _("Voeg NAW gegevens toe") + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td>' + toemailsbutton + '</td>\n' +
         '   </tr>\n';
      page +=
         '   <tr>' +
         '      <td>&nbsp;' + _("Voeg algemene gegevens toe") + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td>' + tovariabutton + '</td>\n' +
         '   </tr>\n';
      if (nplayers > 2) page +=
         '   <tr>' +
         '      <td>&nbsp;' + _("Liever niet in hetzelfde team") + ':&nbsp;</td>\n' +
         '      <td></td>\n' +
         '      <td>' + toavoidsbutton + '</td>\n' +
         '   </tr>\n';
      '</table>\n';


      return page;
   }

   // https://stackoverflow.com/questions/5930892/selecting-an-arbitrary-cell-in-a-table-by-row-and-column-number
   function cell_with_coords(a, i, j) { // table a, row i, col j
      let t = a[0];
      if (t) {
         let cell = t.rows[i].cells[j];
         return $(cell);
      } else
         return t;
   }

   // https://stackoverflow.com/questions/788225/table-row-and-column-number-in-jquery

   function coords_of_cell(c) { // c in tbody
      let i = c.closest('tr').index();
      let j = c.closest('td').index();
      let t = c.closest('tbody');
      return [i, j, t];
   }


   function date2iso(d) {
      var t = d.toISOString();
      return t.split("T")[0];
   }

   function next_date(d, days) {
      let nd = new Date(d + 'T12:00:00');
      nd.setDate(nd.getDate() + days); // increment by days
      return date2iso(nd);
   }


   // https://stackoverflow.com/questions/3730510/javascript-sort-array-and-return-an-array-of-indices-that-indicates-the-position
   // some trivial modifications

   function sortWithIndices(toSort, indices) {
      for (let i = 0; i < toSort.length; i++) {
         toSort[i] = [toSort[i], i];
      }
      toSort.sort(function(a, b) {
         return a[0] - b[0];
      });
      for (let j = 0; j < toSort.length; j++) {
         indices.push(toSort[j][1]);
         toSort[j] = toSort[j][0];
      }
      return toSort;
   }

   function copydim2(a) {
      let b = [];
      for (let i in a) {
         b[i] = a[i].slice();
      }
      return b;
   }

   function formati(a, n) {
      let x = "";
      for (let i in a) {
         let y = ("          " + a[i].toString()).slice(-n);
         x += y;
      }
      return x;
   }

   function formatb(a, n, X, Y) {
      let x = "";
      let y;
      for (let i in a) {
         if (a[i]) {
            y = ("                " + X).slice(-n);
         } else {
            y = ("                " + Y).slice(-n);
         }
         x += y;
      }
      return x;
   }


   function print_forces() {
      print("       A  A  B  B  C  C  D  D");
      for (let i in forces) {
         print(formati([i], 3) + '  ' + formati(forces[i], 3));
      }
   }

   function print_vetos() {
      let h = [];
      for (let i = 0; i < nplayers; i++) {
         h.push(i);
      }
      print('     ', formati(h, 3));
      print()
      for (let i = 0; i < ndates; i++) {
         let x = formati([i], 3) + '   ';
         for (let j = 0; j < nplayers; j++) {
            if (vetos[i][j]) {
               x += '  ' + FREE;
            } else {
               x += '  .';
            }
         }
         print(x);
      }
   }

   // create a crude solution and show this solution
   function quick_solution() {
      scrolltop = $(window).scrollTop();

      let mynpop = npop;
      let myngen = ngen;
      npop = 1;
      ngen = 1;
      compute_result();
      need_apply = nplayers > 0 && nplayers >= ndplayers;
      npop = mynpop;
      ngen = myngen;
      globals2screen();
      $(window).scrollTop(scrolltop);
   }

   function initpicker() {

      $('#firstdate').simplePicker({
         // add style to datepicker
         style: 'white',
         // set first day in a week 0 = Sunday, 1 = Monday ...
         firstday: 1,
         // declare names of the days
         days: [_('Zo'), _('Ma'), _('Di'), _('Wo'), _('Do'), _('Vr'), _('Za')],
         // declare names of the months
         months: [_('Januari'), _('Februari'), _('Maart'), _('April'), _('Mei'), _('Juni'), _('Juli'), _('Augustus'), _('September'), _('Oktober'), _('November'), _('December')],
         // set delimiter
         delimiter: '-',
         dateformat: function() {
            // set dateformat
            return 'yyyy' + this.delimiter + 'mm' + this.delimiter + 'dd';
         },
         handler: handle_update_dates,
         fadeout: true,
      });

      $('#lastdate').simplePicker({
         // add style to datepicker
         style: 'white',
         // set first day in a week 0 = Sunday, 1 = Monday ...
         firstday: 1,
         // declare names of the days
         days: [_('Zo'), _('Ma'), _('Di'), _('Wo'), _('Do'), _('Vr'), _('Za')],
         // declare names of the months
         months: [_('Januari'), _('Februari'), _('Maart'), _('April'), _('Mei'), _('Juni'), _('Juli'), _('Augustus'), _('September'), _('Oktober'), _('November'), _('December')],
         // set delimiter
         delimiter: '-',
         dateformat: function() {
            // set dateformat
            return 'yyyy' + this.delimiter + 'mm' + this.delimiter + 'dd';
         },
         handler: handle_update_dates,
         fadeout: true,
      });
   }

   function initplayers() {
      // initialize #table head with no players
      $('#tableheader th').remove();
      $('#tableheader td').remove();
      $('#tableheader').append('<th><span id="adapt"></span>' + applybutton + '</th>\n');
      $('#tableheader').append(plusplayerth);
   }

   function initrplayers() {
      $('#reserveinput th').remove();
      $('#reserveinput').append('<th class="noinput">' + reserve_player_text + '</th>\n');
      $('#reserveinput').append(plusrplayerth);
   }

   function adaptsize(element) {
      let x = element.val();
      let h = $('#adapt');
      h.text(x);
      let w = h.width();
      element.width(w);
   }

   function adddate() {
      ndates++;
      etc2globals();
      quick_solution();
   }

   function deldate() {
      if (ndates == 1)
         return;
      //dates.pop();
      //ndates = dates.length;
      ndates--;
      etc2globals();
      quick_solution();
   }

   function create_dates() {
      let dats = [];
      dats.push(startdate);
      let dd = new Date(startdate + 'T12:00:00');
      let day = dd.getDay() - 1; // Mon, Tue of first day: 0,1,...
      let wds = playing_days.slice();
      wds.push(day); // wds contains now all weekdays to deal with
      for (let i = 0; i < wds.length; i++) {
         let dif = wds[i] - day;
         if (dif < 0) dif += 7;
         let sd = new Date(startdate + 'T12:00:00');
         sd.setDate(sd.getDate() + dif);
         let isosd = date2iso(sd);
         let w = 0;
         while (true) {
            let nd = new Date(isosd + 'T12:00:00');
            nd.setDate(nd.getDate() + w); // increment by w days
            if (date2iso(nd) > enddate)
               break;
            dats.push(date2iso(nd));
            w += 7;
         }
      }
      dates = [...new Set(dats)].sort(); // a la sort -u
      ndates = dates.length;
   }

   // capitalize first character
   function capitalize_old(p) {
      if (p.length == 0) return p;
      let c = p.substring(0, 1).toUpperCase();
      return c + p.substring(1);
   }

   function capitalize(p) {
      if (p.length == 0)
         return p;
      let ps = p.split(" ");
      let newps = [];
      let j = 0;
      for (let i in ps) {
         if (ps[i].length == 0)
            continue;
         let c = ps[i].substring(0, 1).toUpperCase();
         newps[j] = c + ps[i].substring(1);
         j++;
      }
      return newps.join(" ");
   }


   function addplayer2table(p) {
      var x = '<input class="hplayer" type="text" value="' + capitalize(p) +
         '" placeholder="' + _("voornaam speler") + '">';
      x += '<span class="hplayer_print">&nbsp;' + capitalize(p) + '&nbsp;</span>';
      x += '<button class="delplayer">&nbsp;-&nbsp;</button>';
      $('.plusplayerth').remove();
      $('#table>thead>tr').append('<th class="has-input">' + x + '</th>\n' + plusplayerth);
   };

   function avoids2screen() {
      let avtab = $('#tavoids tbody');
      for (let i = 0; i < nplayers; i++) {
         for (let j = 0; j < nplayers; j++) {
            if (avoids[i][j]) {
               let cell = cell_with_coords(avtab, i, j + 1);
               cell.addClass("avoiding");
            }
         }
      }
   }

   function globals2avoids() {
      avoids.length = 0;
      for (let i = 0; i < nplayers; i++) {
         avoids[i] = new Array(nplayers).fill(0);
      }
      for (let p in players) {
         let pp = players[p].toLowerCase();
         for (let q in persons[pp].avoid) {
            let qq = q.toLowerCase();
            let j = pl2num[qq];
            if (j) {
               let i = pl2num[pp];
               avoids[i][j] = avoids[j][i] = true;
            }
         }
      }
   }

   function addplayer(p) {
      players.push(p);
      nplayers = players.length;
      if (!persons[p])
         persons[p] = {};
      etc2globals();
      quick_solution();
   }

   function addrplayer(p) {
      var x = '<input class="rplayer" type="text" value="' + capitalize(p) +
         '" placeholder="' + _('voornaam reservespeler') + '">';
      x += '<button class="delrplayer">&nbsp;-&nbsp;</button>\n'
      $('.plusrplayerth').remove();
      $('#reserve>thead>tr').append('<th class="has-input">' + x + '</th>' + plusrplayerth + '\n');
      $('.rplayer').each(function() {
         if ($(this).val().length > 0)
            adaptsize($(this));
      });
   }


   function add_emails(p) {
      let has_content = false;
      let ppp = p.slice();

      for (let i in ppp) {
         let p = ppp[i];
         if (p.length == 0) continue;
         let pp = p.toLowerCase();
         let name = persons[pp].name;
         let email = persons[pp].email;
         let phone = persons[pp].phone;
         let strength = Number(persons[pp].strength);
         let gender = Number(persons[pp].gender);
         if (!name) {
            name = "";
         }
         if (!email) {
            email = "";
         }
         if (!phone) {
            phone = "";
         }
         if (!strength) {
            strength = 2;
         }
         if (!gender) {
            gender = 0;
         }
         let r = "bottom";
         let noprint = '';

         if (name.length == 0 && email.length == 0 && phone.length == 0)
            noprint = 'class="noprint"';
         else
            has_content = true;

         let b =
            '\n<tr ' + noprint + '>\n' +
            '   <td class="noinput">' + '&nbsp;' + capitalize(p) + '&nbsp;</td>\n' +
            '   <td class="has-input"><input class="name"  type="text" placeholder="' + _("Vul in: volledige naam") + '" value="' + name + '"></td>\n' +
            '   <td class="has-input"><input class="email" type="text" placeholder="' + _("Vul in: e-mail") + '" value="' + email + '"></td>\n' +
            '   <td class="has-input"><input class="phone" type="text" placeholder="' + _("Vul in: telefoon") + '" value="' + phone + '"></td>\n' +
            '   <td class="strength noinput noprint mf-menu">&nbsp;' + snames[strength - 1] + '&nbsp;' +
            '      <ul>\n' +
            '         <li class="strengthclick" choice="1" person="' + p + '">' + snames[0] + '</li>\n' +
            '         <li class="strengthclick" choice="2" person="' + p + '">' + snames[1] + '</li>\n' +
            '         <li class="strengthclick" choice="3" person="' + p + '">' + snames[2] + '</li>\n' +
            '         <li class="strengthclick" choice="0" person="' + p + '">' + _("onveranderd") + '</li>\n' +
            '      </ul>\n' +
            '   </td>\n' +

            '   <td class="gender noinput noprint mf-menu">&nbsp;' + gnames[gender] + '&nbsp;' +
            '      <ul>\n' +
            //'         <li><a class="genderclick" choice="0" person="' + p + '">&nbsp;' + gnames[0] + '&nbsp;</a></li>\n' +
            '         <li class="genderclick" choice="0" person="' + p + '">&nbsp;' + longgnames[0] + '&nbsp;</li>\n' +
            '         <li class="genderclick" choice="1" person="' + p + '">&nbsp;' + longgnames[1] + '&nbsp;</li>\n' +
            '         <li class="genderclick" choice="9" person="' + p + '">&nbsp;' + _("onveranderd") + '&nbsp;</li>\n' +
            '      </ul>\n' +
            '   </td>\n' +
            '</tr>\n';

         $('#emailbody').append(b);
      }
      return has_content;
   }

   function sum(a) {
      let s = 0;
      let n = a.length;
      for (let i = 0; i < n; i++) {
         s += a[i];
      }
      return s;
   }

   // Using own random generator: want to get the same results in
   // different browser
   // Taken from "Random generators are hard to find"

   function random() {
      const a = 16807.0;
      const m = 2147483647.0;
      random.seed = (a * random.seed) % m;
      return random.seed / m;
   }

   function validate_random() {
      let r = random.seed;
      random.seed = 1;
      let x;
      let rc;
      for (var i = 0; i < 10000; i++)
         x = random();
      if (random.seed == 1043618065) {
         print(1043618065, random.seed, x, " random OK");
         rc = true;
      } else {
         print(1043618065, random.seed, x, " random NOT OK");
         rc = false;
      }
      random.seed = r;
      return rc;
   }

   function randint(n) { //  0<=randind<n
      return Math.floor(n * random());
   }
   // https://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle#The_%22inside-out%22_algorithm
   function shuf(a) {
      for (let i = 0; i < a.length; i++) {
         let j = randint(i + 1);
         if (i != j) a[i] = a[j];
         a[j] = i;
      }
   }

   // very sometimes, the drinks are not distributed evenly when
   // using the natural order of datums to compute who pays, so
   // we do a number of calculations with different
   // order of datums and choose the best
   function put_drinks_ng(sol, sp) { // result, sumplay
      let ntry = 40;
      let order = [];
      let sumdr = [];
      let totmin = 1.0e20;
      for (let i = 0; i < ndates; i++)
         order.push(i);
      let ordermin = order.slice();
      // This function can be called a random number of times by user intervention:
      // if a tablecell is clicked but not changed
      // This would cause seed to change between calls, resulting in a possibly
      // other drinks scheme. So, we save the seed and set it back afterwards.
      let oldseed = random.seed;
      for (let tries = 0; tries < ntry; tries++) {
         shuf(order);
         sumdr = put_drinks_ng1(sol, order, false);
         let total = 0;
         for (let j = 0; j < nplayers; j++) {
            let d = sumdr[j] / sp[j];
            total += d * d * d * d;
         }
         // the best will have the minimum total
         if (total < totmin) {
            totmin = total;
            ordermin = order.slice();
         }
      }
      put_drinks_ng1(sol, ordermin, true);
      random.seed = oldseed;
   }

   function put_drinks_ng1(sol, order, putit) { // result, sumplay, order, on_screen
      let tab = $("#tablebody");
      let numpayers = daypayers;
      if (numpayers == 0) {
         $('#sumpayrow').hide();
      }
      if (numpayers == 0 || nplayers == 0 || nplayers < ndplayers) {
         let sumd = [];
         for (let i = 0; i < nplayers; i++)
            sumd.push(i);
         return sumd;
      }

      let drink = new Array(nplayers).fill(0); // how many times the player has payed
      let sumdrinks = new Array(nplayers).fill(0);
      let played = new Array(nplayers).fill(0); // number of plays so far

      for (let jj = 0; jj < ndates; jj++) {
         let date = order[jj];
         let actplayers = new Array(nplayers).fill(-1); // will contain the numbers of the playing players -1: player does not play
         for (let j = 0; j < ndplayers; j++) {
            let p = sol[date][j];
            if (p >= 0) {
               actplayers[p] = 1;
            }
         }
         for (let j = 0; j < nplayers; j++) {
            if (actplayers[j] == 1)
               played[j]++;
         }

         let dg = []; // will contain [number_of_payed drinks/played,player_number], in an
         //            // array of length playing_players
         for (let j = 0; j < nplayers; j++) {
            if (actplayers[j] == 1) {
               dg.push([drink[j] / played[j], j]);
            }
         }
         // put the one with the lowest drinks/played on top:
         dg.sort(function(a, b) {
            if (a[0] == b[0])
               return a[1] - b[1]; // reproducible sort
            return a[0] - b[0];
         });

         let n = numpayers; // n will become the number of paying players for this date

         let sumact = 0; // n cannot be > number of actual players
         for (let j = 0; j < nplayers; j++)
            if (actplayers[j] == 1)
               sumact++;
         if (n > sumact)
            n = sumact;

         let payers = new Set(); // will contain the the (numbers of the) payers  (usually one payer)
         for (let j = 0; j < n; j++) {
            payers.add(dg[j][1]);
         }
         payers.forEach(function(x) { // update drink for each payer
            drink[x]++;
         });

         for (let j = 0; j < nplayers; j++) {
            let cell;
            let t;
            if (putit) {
               cell = cell_with_coords(tab, date, j + 1);
               t = cell.text();
            }
            if (actplayers[j] == 1) {
               if (payers.has(j)) {
                  sumdrinks[j]++;
                  if (putit)
                     cell.html(t + '&nbsp;<span class="drinkcode">' + DRINKTXT + '</span>');
               } else {
                  if (putit)
                     cell.html(t + "&nbsp;&nbsp;&nbsp;")
               }
            }
         }
      }
      //sum of drinks
      let sumpayrow = $('#sumpayrow').children('.sumpay');
      for (let j = 0; j < nplayers; j++) {
         let paycell = sumpayrow.eq(j);
         paycell.text(sumdrinks[j]).addClass("to_compute");
      }
      $('#sumpayrow').show();
      return sumdrinks;
   }

   function needupdate(x) {
      if (x) {
         $('#fill').css("color", "black").css("background", "yellow").attr("need", "yes");
         return;
      }
      $('#fill').css("color", "gray").css("background", "white").attr("need", "no");
   }

   function date2weekday(d, sh) {
      let dd = new Date(d);
      if (sh) {
         let x = dd.getDay() - 1;
         if (x < 0)
            x += 7;
         return shortdays[x];
      }
      return weekdays[dd.getDay()];
   }

   function globals2screen() {
      scrolltop = $(window).scrollTop();

      init_lang();

      let nteams = Math.floor((ndplayers + 1) / 2);
      define_texts();
      define_buttons();
      $('#top').html(init_top());
      $("#toptitle").click(function() {
         do_debug();
      });
      $('#menu').html(initts());
      $('#firstdate').val(startdate);
      $('#ndplayers').val(ndplayers);
      $('#daypayers').val(daypayers);
      $('#fiddle').val(fiddle);
      $('#npop').val(npop);
      $('#ngen').val(ngen);
      $('#teams').text([no_text, yes_text][maketeams]);

      $('#table').remove();
      $('#tstable').html(init_table());

      $('.applywarning').html(
         _("Uw wijzigingen zijn nog niet geheel verwerkt") + '.<br>\n' +
         '<b>' + _("Klik hier om te verwerken") + '</b> ' + _("of gebruik de oranje knop") +
         '<b> ' + process_text + '</b> ' + _("in het schema") + '.'
      );
      $('.weekday-show').html(_(date2weekday(startdate, true)));

      let dd = new Date(startdate);
      let startweekday = dd.getDay() - 1;

      if (startweekday < 0)
         startweekday = 6;
      $('.weekday' + startweekday).addClass('weekday_chosen');
      for (let i = 0; i < playing_days.length; i++)
         $('.weekday' + playing_days[i]).addClass('clicked');

      let warnings = false;

      // adapt text in legenda:
      if (maketeams) {
         $("#playcode").text("A,B,..");
         $("#plays").html(plays_in_team_text + " A,B,..");
      } else {
         $("#playcode").text(PLAYTXT);
         $("#plays").html(plays_text);
      }
      // initialize avoids table
      init_avoids();

      // initialize head, without players:
      initplayers();

      etc2globals();

      // put players in head of table:
      for (let i = 0; i < nplayers; i++) {
         addplayer2table(players[i]);
      }
      $('.hplayer').each(function() {
         if ($(this).val().length > 0)
            adaptsize($(this));
         $(this).show();
      });

      let tab = $("#tablebody");

      let cell = cell_with_coords(tab, 0, 0);
      let day = "";
      let showday = (playing_days.length > 0);
      if (playing_days.length == 1 && startweekday == playing_days[0])
         showday = false;
      if (showday)
         day = '&nbsp;' + date2weekday(dates[0], true);

      cell.html(dates[0] + day).addClass("rowdate has-input");
      let w = "<td class='warning noinput'></td>\n";
      let c = "<td class='tablecell'></td>\n";
      for (let i = 0; i < nplayers; i++) {
         $("#firstrow").append(c);
      }
      $("#firstrow").append(w);

      // create empty scheme
      for (let i = 1; i < ndates; i++) {
         let day = "";
         if (showday)
            day = '&nbsp;' + date2weekday(dates[i], true);

         let row = '\n<tr><td class="rowdate has-input">' + dates[i] + day + '</td></tr>\n';
         row = $(row);
         for (let i = 0; i < nplayers; i++) {
            row.append(c);
         }
         row.append(w);
         tab.append(row);
      }
      initpicker();
      for (let i = 0; i < nplayers; i++) {
         $("#sumplayrow").append("<td class='sums sumplay noinput'></td>");
         $("#sumpayrow").append("<td class='sumpay noinput'></td>");
      }

      $('#versiondate').text(versiondate);
      $('#versionrev').text(versionrev);

      initrplayers();
      autosize($('#varia'));

      for (let i in rplayers) {
         addrplayer(rplayers[i]);
      }

      // by default, everybody is always free and to_compute
      //if (nplayers > 100 * ndplayers)
      //  $(".tablecell").text(NOPLAYTXT).addClass("to_compute");
      // but, if nplayers < ndplayers: 
      //else
      $(".tablecell").text(" ").addClass("to_compute");

      // warning for to few players
      if (nplayers > 0 && nplayers >= ndplayers && players[nplayers - 1].length > 0) {
         for (let i = 0; i < ndates; i++) {
            if (isfreeday[i]) continue;
            for (let j = 0; j < ndplayers; j++) {
               if (result[i][j] < 0) {
                  let cell = cell_with_coords(tab, i, nplayers + 1);
                  cell.html('&nbsp;' + NOTENOUGHTXT);
                  warnings = true;
                  break;
               }
            }
         }
      }

      // fill in free days
      for (let i in isfreeday) {
         if (isfreeday[i]) {
            for (let j = 0; j < 1 + nplayers; j++) {
               let cell = cell_with_coords(tab, i, j);
               cell.addClass("freeday").removeClass("to_compute");
               if (j > 0) cell.text('');
            }
            cell = cell_with_coords(tab, i, nplayers + 1);
            cell.html('&nbsp;' + FREEDAYTXT);
            warnings = true;
         }
      }

      // best solution is in result


      const sumplay = new Array(nplayers).fill(0); // will contain the number of plays for each player
      // fill in playing players
      if (nplayers > 0 && nplayers >= ndplayers) {
         for (let i = 0; i < ndates; i++) {
            if (isfreeday[i])
               continue;
            if (!isfreeday[i]) {
               for (let j = 0; j < nplayers; j++) {
                  if (players[j].length > 0) {
                     let cell = cell_with_coords(tab, i, j + 1);
                     cell.html(NOPLAYTXT);
                  }
               }
            }
            const teamof = new Array(nplayers).fill(' ');
            let t = 0;
            for (let j = 0; j < ndplayers; j++) {
               let k = result[i][j];
               if (k >= 0 && teamof[k] == ' ') {
                  let cell = cell_with_coords(tab, i, 1 + k);
                  if (maketeams == 0)
                     cell.text(PLAYTXT);
                  else
                     cell.text(letters[t]);
                  if (j % 2 == 1)
                     t++;
               }
               if (isfreeday[i]) continue;
               sumplay[k]++;
            }
         }
      }

      // fill in absents

      if (nplayers > 0) {
         for (let i = 0; i < ndates; i++) {
            if (isfreeday[i])
               continue;
            for (let j = 0; j < nplayers; j++) {
               if (avail[i][j] == 0) {
                  let cell = cell_with_coords(tab, i, j + 1);
                  cell.addClass("absent").text(ABSENTTXT).removeClass("to_compute");
               }
            }
         }
      }

      // fill in forces
      if (nplayers > 0) {
         for (let i = 0; i < ndates; i++) {
            if (isfreeday[i])
               continue;
            for (let j = 0; j < ndplayers; j++) {
               let f = forces[i][j];
               if (f >= 0) {
                  let cell = cell_with_coords(tab, i, f + 1);
                  cell.addClass("force").removeClass("to_compute");
                  // 0-> A, 1-> A, 2->B, 3->B ...
                  let t = Math.floor(j / 2);
                  let x = PLAYTXT;
                  if (maketeams)
                     x = letters[t];
                  cell.attr("force", letters[t]).text(x);
               }
            }
         }
      }

      // fill in avoids
      avoids2screen();

      // fill in vetos
      if (nplayers > 0) {
         for (let i = 0; i < ndates; i++) {
            if (isfreeday[i])
               continue;
            for (let j = 0; j < nplayers; j++) {
               if (vetos[i][j]) {
                  let cell = cell_with_coords(tab, i, j + 1);
                  cell.addClass("force").removeClass("to_compute");
                  cell.attr("force", NOPLAYTXT).html(NOPLAYTXT);
               }
            }
         }
      }

      // fill in sumplay
      if (nplayers > 0 && nplayers >= ndplayers) {
         $('.sumplay').each(function() {
            let cell = $(this);
            let [i, j, dummy] = coords_of_cell(cell);
            cell.text("" + sumplay[j - 1]).addClass("to_compute");
         });
      }

      // fill in payers
      put_drinks_ng(result, sumplay);

      // take care of month changes
      {
         let tprev = $('#table>tbody>tr:eq(0) td:eq(0)').text().substr(0, 7);
         let classes = ['white', 'month'];
         let color = 0;
         let n = 0;
         $('#table>tbody>tr').each(function() { // loop over dates
            let t = $(this).children('td:eq(0)').text();
            let mc = '';
            if (tprev != t.substr(0, 7)) {
               color = 1 - color; //switch color at month change
               mc = ' monthchange';
            }
            $('.tablecell,.rowdate', this).addClass(classes[color]).addClass(mc);
            tprev = t.substr(0, 7);
         });
      }

      // take care of email adresses etc
      {
         $('#emailbody>tr').remove();
         let has_players = add_emails(players);
         if (rplayers && rplayers.length > 0) {
            $('#emailbody').append('<tr id="reserveheader><th class="reserveheader noinput" style="text-align:center;padding-left:0.5em;padding-right:0.5em;">\n' +
                  '<th>\n' + reserve_player_text + '</th>\n') +
               '</tr>\n';
         }

         let has_rplayers = add_emails(rplayers);
         if (has_players || has_rplayers)
            $('#emails').removeClass("noprint");
         else
            $('#emails').addClass("noprint");

         if (has_players)
            $('#emailheader').removeClass("noprint");
         else
            $('#emailheader').addClass("noprint");

         if (has_rplayers)
            $('#reserveheader').removeClass("noprint");
         else
            $('#reserveheader').addClass("noprint");
      }

      // varia
      $('#varia').val(varia);
      autosize.update($('#varia'));
      if (varia.length == 0)
         $('#tvaria').addClass("noprint");
      else
         $('#tvaria').removeClass("noprint");

      if ((need_apply || resultversion != VERSION) && nplayers >= ndplayers) {
         $('.apply').addClass('need_apply');
         $(".applywarning").show();
      } else {
         $('.apply').removeClass('need_apply');
         $('.to_compute').removeClass('to_compute');
         $(".applywarning").hide();
      }

      //version
      //checkcrc();
      $('#versiondate').text(versiondate);
      $('#versionrev').text(versionrev);

      $(".tablecell").each(function() {
         let cell = $(this);
         cell.attr("tabIndex", "-1"); // get focus when clicked
         let [i, j, dummy] = coords_of_cell(cell);
         j--;
         cell.addClass('mf-menu-nohover');
         let x = '' +

            '   <ul>\n' +
            '      <li class="tableclick" choice="auto">' + _("standaard") + '</li>\n' +
            '      <li class="tableclick" choice="absent">' + _("verhinderd") + '</li>\n' +
            '      <li class="tableclick" choice="veto">' + _("vrij") + '</li>\n';
         for (let t = 0; t < nteams; t++) {
            let code = letters[t];
            x += '    <li class="tableclick" choice="' + code + '">' + _("in team") + ' ' + code + '</li>\n';
         }
         x += '' +
            '      <li class="tableclick" choice="cancel">' + _("onveranderd") + '</li>\n' +
            '   </ul>\n';

         cell.append(x);
      });


      // remove .warnings column if there are no warnings (only affects print/pdf)
      if (!warnings)
         $('.warning').hide();

      // handle language:

      if (!languages.includes(lang))
         lang = 'en';
      $(".lang_chosen").removeClass("lang_chosen");
      $(".lang_" + lang).addClass("lang_chosen");

      // handle game type
      if (!game_type || game_type.trim() == '')
         game_type = "Tennis";
      game_type = game_type.trim();
      $('#gametype').val(game_type);
      $('.game').text(game_type);

      $('#help').html(init_help());

      $(window).scrollTop(scrolltop);
   }

   function handle_tableclick() {
      let a = 'A'.charCodeAt(); // 65
      let clicked = $(this);
      let [i, j, t] = coords_of_cell(clicked);
      j--;
      i = Number(i);
      j = Number(j);
      let d = dates[i];
      let p = players[j];

      let da = !(d in persons[p].absent);
      let dv = !(d in persons[p].veto);
      let df = !(d in persons[p].force);

      let change = true;

      let x = clicked.attr("choice");

      switch (x) {
         case "veto":
            if (d in persons[p].veto && df && da)
               change = false;
            persons[p].veto[d] = 1;
            delete persons[p].force[d];
            delete persons[p].absent[d];
            break;

         case "absent":
            if (d in persons[p].absent && dv && df)
               change = false;
            persons[p].absent[d] = 1;
            delete persons[p].veto[d];
            delete persons[p].force[d];
            break;

         case "auto":
            if (!(d in persons[p].veto) && dv && df && da)
               change = false;
            delete persons[p].veto[d];
            delete persons[p].force[d];
            delete persons[p].absent[d];
            break;

         case "cancel":
            change = false;
            break;

         default: // should be a team code: 'A', 'B', ...
            if (!x) { // should not happen
               return;
            }

            let team = x.charCodeAt() - a;
            if (d in persons[p].force && persons[p].force[d] == team && dv && da)
               change = false;;
            persons[p].force[d] = team;
            delete persons[p].veto[d];
            delete persons[p].absent[d];
            break;
      }

      if (change) {
         cell_with_coords(t, i, j + 1).css("animation-name", "animate");
         setTimeout(function() {
            cell_with_coords(t, i, j + 1).css("animation-name", "");
            etc2globals();
            quick_solution();
         }, 200);
      } else {
         scrolltop = $(window).scrollTop();
         globals2screen();
      }
   }

   function handle_strengthclick() {
      let clicked = $(this);
      let s = clicked.attr('choice');
      let p = clicked.attr('person');
      let td = clicked.closest('td');
      if (s == 0 || persons[p].strength == s) {
         //scrolltop = $(window).scrollTop();
         globals2screen();
      } else {
         td.css("animation-name", "animate");
         setTimeout(function() {
            persons[p].strength = Number(s);
            etc2globals();
            quick_solution();
         }, 200);
      }
   }

   function handle_genderclick() {
      let clicked = $(this);
      let g = clicked.attr('choice');
      let p = clicked.attr('person');
      let td = clicked.closest('td');
      if (g == 9 || persons[p].gender == g) {
         //scrolltop = $(window).scrollTop();
         globals2screen();
      } else {
         td.css("animation-name", "animate");
         setTimeout(function() {
            persons[p].gender = Number(g);
            etc2globals();
            quick_solution();
         }, 200);
      }
   }

   function dates2numbers(dates) {
      let x = {};
      for (let i in dates) {
         x[dates[i]] = Number(i);
      }
      return x;
   }

   function players2numbers(p) { // p: players, returns {player:0,otherplayer:1,...}
      let p2n = {};
      for (let i in p) {
         p2n[p[i].toLowerCase()] = Number(i);
      }
      return p2n;
   }

   function check_result() {
      if (result.length != ndates) {
         quick_solution();
         return;
      }
      for (let i = 0; i < ndates; i++) {
         if (result[i].length != ndplayers) {
            quick_solution();
            return;
         }
      }
      for (let i = 0; i < ndates; i++) {
         for (let j = 0; j < ndplayers; j++) {
            if (result[i][j] < -1 || result[i][j] >= nplayers) {
               quick_solution();
               return;
            }
         }
      }
   }

   function sanitize_players(p, ps) {
      // p: input players
      // ps: in/out persons
      // returns: [players, nplayers, pl2num]
      let pp = [];
      for (let i in p) {
         pp.push(p[i].toLowerCase().trim().replace(/\s\s+/g, ' '));
      }

      // sort "" after all
      pp.sort(function(a, b) {
         if (a.length == 0) return 1;
         if (b.length == 0) return -1;
         if (b > a) return -1;
         if (b < a) return 1;
         return 0;
      });
      let ppp = [];
      if (pp.length >= 1) {
         ppp.push(pp[0]);
         for (let i = 1; i < pp.length; i++) {
            if (ppp[ppp.length - 1] != pp[i]) ppp.push(pp[i]);
         }
      }
      for (let i in ppp) {
         if (!(ppp[i] in ps)) ps[ppp[i]] = {};
      }
      let p2n = {};
      for (let i in ppp) {
         p2n[ppp[i]] = Number(i);
      }
      for (let p in ps) {
         if (!ps[p].strength)
            ps[p].strength = 2;
         if (!ps[p].gender)
            ps[p].gender = 0;
         if (!ps[p].email)
            ps[p].email = "";
         if (!ps[p].phone)
            ps[p].phone = "";
         if (!ps[p].name)
            ps[p].name = "";
         if (!ps[p].absent)
            ps[p].absent = {};
         if (!ps[p].veto)
            ps[p].veto = {};
         if (!ps[p].force)
            ps[p].force = {};
         if (!ps[p].avoid)
            ps[p].avoid = {};
      }
      return [ppp, ppp.length, p2n];
   }

   function sanitize_persons(p) {
      for (let item in p) {
         if (!persons[item].email)
            persons[item].email = "";
         if (!persons[item].phone)
            persons[item].phone = "";
         if (!persons[item].name)
            persons[item].name = "";
         persons[item].strength = get_int(persons[item].strength, 2);
         //if (!persons[item].strength)
         //  persons[item].strength = 2;
         persons[item].gender = get_int(persons[item].gender, 0);
         //if (!persons[item].gender)
         //  persons[item].gender = 0;
         if (!persons[item].absent)
            persons[item].absent = {};
         if (!persons[item].veto)
            persons[item].veto = {};
         if (!persons[item].avoid)
            persons[item].avoid = {};
         if (!persons[item].force)
            persons[item].force = {};
      }
   }

   //returns s converted to int, default d
   function get_int(s, d) {
      let x = parseInt(s);
      if (isNaN(x))
         return d;
      return x;
   }

   function data2globals() {
      // version of result
      if (data.resultversion)
         resultversion = data.resultversion;
      else
         resultversion = "0";

      // persons
      persons = {};
      if (data.persons) {
         let s = JSON.stringify(data.persons);
         persons = JSON.parse(s);
         sanitize_persons(persons);
      }

      startdate = date2iso(new Date()); // today
      startdate = next_date(startdate, 7); // + one week
      if ("startdate" in data) {
         startdate = data.startdate;
      }

      enddate = next_date(startdate, 42);
      if ("enddate" in data) {
         enddate = data.enddate;
      }

      playing_days = [];
      if ("playing_days" in data) {
         playing_days = data.playing_days.slice();
      }

      scrolltop = $(window).scrollTop();

      // players
      [players, nplayers, pl2num] = sanitize_players(data.players, persons);

      if (data.dayplayers)
         ndplayers = get_int(data.dayplayers, 4); // compatability with previous version
      else
         ndplayers = get_int(data.ndplayers, 4);

      /*
      let defnpop = 50;
      npop = get_int(data.npop,defnpop);

      let defngen = 4000;
      ngen = get_int(data.ngen,defngen);
      */

      daypayers = get_int(data.daypayers, 1);

      maketeams = get_int(data.maketeams, 1);

      fiddle = get_int(data.fiddle, 1);

      freedays = {};
      if (data.offdays) { // compatability with previous version
         for (let i in data.offdays) {
            freedays[i] = 1;
         }
      } else {
         for (let i in data.freedays) {
            freedays[i] = 1;
         }
      }

      // gender and strength
      get_gender_strength();

      // ndates  compatability
      if ("ndates" in data && !("enddate" in data)) {
         ndates = Math.floor(data.ndates);
         if (ndates <= 0)
            ndates = defndates;
         enddate = next_date(startdate, 7 * ndates);
      }

      // rplayers

      let dummy;
      [rplayers, nrplayers, dummy] = sanitize_players(data.rplayers, persons);

      // version
      try {
         oldversiondate = data.version.date;
         oldversionrev = data.version.rev;
      } catch (e) {
         oldversiondate = date2iso(new Date());
         oldversionrev = 1;
      }
      versiondate = oldversiondate;
      versionrev = oldversionrev;

      etc2globals();

      // varia
      varia = data.varia;
      if (!varia) varia = "";

      // language
      if (data.lang)
         lang = data.lang;

      // game type
      if (data.gametype)
         game_type = data.gametype;
      else
         game_type = '';

      need_apply = data.need_apply;
      if (nplayers < ndplayers)
         need_apply = false;
      result = [];
      if (data.result)
         result = copydim2(data.result);
      check_result();

      //crc must be the last, data2crc expects all globals to be set
      crc = data2crc();
   }

   // put essential globals in data
   function globals2data() {
      data.resultversion = resultversion;
      let s = JSON.stringify(persons);
      data.persons = JSON.parse(s);

      data.startdate = startdate;
      data.enddate = enddate;

      data.players = players.slice();
      data.ndplayers = ndplayers;
      data.dayplayers = ndplayers; // compatability with previous version

      data.playing_days = playing_days.slice();

      data.gametype = game_type;
      data.daypayers = daypayers;
      data.maketeams = maketeams;
      data.fiddle = fiddle;

      data.freedays = {};
      for (let i in freedays)
         data.freedays[i] = 1;

      data.offdays = {}; // compatability with prevoius version
      for (let i in freedays)
         data.offdays[i] = 1;

      data.ndates = ndates;

      data.rplayers = rplayers;

      data.varia = varia;

      if (!data.version)
         data.version = {};
      data.version.rev = versionrev;
      data.version.date = versiondate;

      data.result = copydim2(result);
      data.need_apply = need_apply;

      data.lang = lang;
   }

   // dates, players etc from global persons, ndates etc. 
   function etc2globals() {

      dates = [];
      dates[0] = startdate;
      if (false) {
         for (let i = 1; i < ndates; i++) {
            dates[i] = next_date(dates[i - 1], 7);
         }
      } else {
         create_dates();
      }

      da2num = dates2numbers(dates);
      let dummy;
      [players, nplayers, pl2num] = sanitize_players(players, persons);
      [rplayers, nrplayers, dummy] = sanitize_players(rplayers, persons);

      // ndplayers
      if (ndplayers <= 0)
         ndplayers = 4;
      if (ndplayers > maxndplayers)
         ndplayers = maxndplayers;


      // isfreeday
      isfreeday = new Array(ndates);
      isfreeday.fill(false);
      if ("freedays" in data) {
         for (let item in freedays) {
            let x = dates.indexOf(item);
            if (x >= 0)
               isfreeday[x] = true;
         }
      }
      // avail
      avail.length = 0;
      for (let i = 0; i < ndates; i++) {
         avail[i] = new Array(nplayers).fill(1);
      }
      for (let p in players) {
         let pp = players[p].toLowerCase();
         for (let d in persons[pp].absent) {
            let n = da2num[d];
            if (!(n === undefined)) {
               avail[n][pl2num[pp]] = 0;
            }
         }
      }

      //      gender
      gender = [];
      for (let i in players) {
         let p = players[i];
         gender.push(persons[p].gender);
      }

      // strength
      strength = [];
      for (let i in players) {
         let p = players[i];
         strength.push(persons[p].strength);
      }

      // avoids
      globals2avoids();

      // forces and vetos
      forces.length = 0;
      for (let i = 0; i < ndates; i++) {
         forces[i] = new Array(ndplayers).fill(-1);
      }
      vetos.length = 0;
      for (let i = 0; i < ndates; i++) {
         vetos[i] = new Array(nplayers).fill(false);
      }

      nvetos = 0;
      nforces = 0;
      for (let p in players) {
         let pp = players[p].toLowerCase();
         let f = persons[pp].force;
         for (let d in f) {
            let i = da2num[d];
            if (!(i === undefined)) {
               let j = f[d] * 2;
               if (j < ndplayers) {
                  nforces++;
                  if (forces[i][j] == -1)
                     forces[i][j] = pl2num[pp];
                  else
                     forces[i][j + 1] = pl2num[pp];
               }
            }
         }
         let v = persons[pp].veto;
         for (let d in v) {
            let i = da2num[d];
            if (!(i === undefined)) {
               vetos[i][pl2num[pp]] = true;
               nvetos++;
            }
         }
      }

      // sumavail
      sumavail = new Array(nplayers).fill(0);
      for (let i = 0; i < ndates; i++) {
         if (isfreeday[i])
            continue;
         for (let j = 0; j < nplayers; j++) {
            if (!vetos[i][j] && avail[i][j] != 0) { // player[j] could play
               sumavail[j]++;
            }
         }
      }

      // daypayers
      if (daypayers > ndplayers)
         daypayers = ndplayers;
      if (daypayers < 0)
	 daypayers = 0;

   }

   function get_gender_strength() {
      const defgender = 0;
      gender.length = 0;
      const defstrength = 2;
      strength.length = 0;
      for (let i in players) {
         strength[i] = defstrength;
         gender[i] = defgender;
         let p = players[i].toLowerCase();
         if (p in persons) {
            if ("strength" in persons[p]) {
               strength[i] = Math.floor(persons[p].strength);
            }
            if ("gender" in persons[p]) {
               gender[i] = Math.floor(persons[p].gender);
            }
         }
         if (strength[i] < 1 || strength[i] > 3)
            strength[i] = defstrength;
         if (gender[i] < 0 || gender[i] > 1)
            gender[i] = defgender;
      }
   }


   function init_avoids() {
      $('#tavoids').remove();
      $('#avoids').append('<table id="tavoids"></table>\n');
      $('#tavoids').append('<thead><tr><td></td></tr></thead>\n');
      if (nplayers < 3) {
         $('#avoids').hide();
         return;
      }

      let h = $('#tavoids thead tr');
      h.append('<th>&nbsp;&nbsp;</th>\n')
      for (let p in players)
         h.append('<th>&nbsp;' + capitalize(players[p]) + '&nbsp;</th>\n');
      $('#tavoids').append('<tbody>\n');
      let x = "";
      for (let p in players) {
         x += '<td class="avoidcell"></td>\n';
      }
      for (let p in players) {
         $('#tavoids tbody').append('<tr><th>' + capitalize(players[p]) + '</th>' + x + '</tr>\n');
      }

      if (nplayers == 0)
         return;

      $('#avoids').append('<table id="iavoids" class="noprint mf-region"</table>\n');
      x = "<tr>";

      for (let i = 0; i < nplayers; i++) {
         x +=
            '<td class="iavoid noinput mf-menu has-input">' + capitalize(players[i]) +
            '   <ul>\n';
         let flag;
         for (let j = 0; j < nplayers; j++) {
            if (i == j)
               continue;
            if (avoids[i][j])
               flag = '-&nbsp;';
            else
               flag = '&nbsp&nbsp;';

            x +=
               '      <li class="avoidsclick" i="' + i + '" j="' + j + '">' + flag + capitalize(players[j]) + '      </li>\n'
         }
         x +=
            '      <li class="avoidsclick" i="-1" j="-1">' + _("onveranderd") + '      </li>\n' +
            '   </ul>\n' +
            '</td>\n'
      }

      x += "</tr>\n";

      $('#iavoids').append(x);


      $('#avoids').append('<div class="noprint" id="avoidsdiv"></div');


      let needed = false;
      for (let i = 0; i < nplayers; i++) {
         for (let j = 0; j < nplayers; j++) {
            if (avoids[i][j])
               needed = true;
         }
      }

      if (!needed)
         return;

      $('#avoidsdiv').append('<table><tr><td style="border:none;">' + _("Uw keuze") + ':</td></tr></table>\n');
      $('#avoidsdiv').append('<table id="davoids"></table>\n');

      let row = 0;
      for (let i = 0; i < nplayers; i++) {
         let p = players[i];
         let comment;
         if (row == 0)
            comment = '&nbsp;' + _("niet in hetzelfde team als") + ":";
         else
            comment = '"';
         let x = '<tr><td><b>&nbsp;' + capitalize(p) + '</b></td>' + '<td style="text-align:center;">' + comment + '</td>\n';
         let count = 0;
         let comma = '';
         x += '<td><b>';
         for (let j = 0; j < nplayers; j++) {
            if (i != j && avoids[i][j]) {
               if (count > 0)
                  comma = ',';
               x += comma + '&nbsp;' + capitalize(players[j]);
               count++;
            }
         }
         x += '&nbsp;</b></td></tr>\n';
         if (count > 0) {
            row++;
            $("#davoids").append(x);
         }
      }
   }

   function handle_avoidsclick() {
      let clicked = $(this);
      let i = clicked.attr("i");
      if (i < 0) {
         //scrolltop = $(window).scrollTop();
         globals2screen();
         return;
      }
      let p = players[i];
      let q = players[clicked.attr("j")];

      let td = clicked.closest('td');
      td.css("animation-name", "animate");
      setTimeout(function() {
         if (persons[p].avoid[q] || persons[q].avoid[p]) {
            delete persons[p].avoid[q];
            delete persons[q].avoid[p];
         } else {
            persons[p].avoid[q] = 1;
            persons[q].avoid[p] = 1;
         }
         etc2globals();
         quick_solution();
      }, 200);
   }

   function data2crc() {
      // return stringified data, version replaced by constant value
      globals2data();
      let d = data.version.date;
      let r = data.version.rev;
      data.version.date = "2000-01-01";
      data.version.rev = 1;
      let s = JSON.stringify(data);
      data.version.date = d;
      data.version.rev = r;
      return s;
   }


   function makedate() {
      let firstdate = startdate;
      let lastdate = dates[dates.length - 1];
      let wds = playing_days.slice();

      let dd = new Date(startdate + 'T12:00:00');
      let day = dd.getDay() - 1; // Mon, Tue of first day: 0,1,...
      if (!wds.includes(day))
         wds.push(day);
      wds.sort();

      let r = game_type + '_';
      for (let i in wds)
         r += shortdays[wds[i]].toLowerCase() + '_';
      r += firstdate + '_' + lastdate;

      return r;
   }

   function download() { // from here to user's file system  (save)
      checkcrc();
      globals2data();
      let myBlob = new Blob([JSON.stringify(data, null, 1)]);
      let blobUrl = URL.createObjectURL(myBlob);
      let link = document.createElement("a"); // Or maybe get it from the current document
      link.href = blobUrl;

      link.download = /*_("schema") + '-' +*/ makedate() + '.txt';
      document.title = /*_("schema") + '-' +*/ makedate();
      link.innerHTML = "Download";
      link.hidden = 1;
      link.click();
      crc = data2crc();
   }

   function upload() { // from user's file system to here  (open)
      //print("this is upload");
      if (crc != data2crc()) {
         let rc = confirm(_("U hebt deze sessie nog niet opgeslagen. Toch doorgaan met openen van bewaarde sessie?"));
         if (!rc)
            return;
      }
      var link = document.createElement("input");
      link.id = 'uploadinput'; // see #uploadinput for handling the file
      link.name = 'files[]';
      link.type = 'file';
      $('#menu').append(link);
      link.click();
      link.style = 'visibility: hidden;';
   }

   function print_result() {
      etc2globals();
      globals2screen();

      const title = makedate();
      checkcrc();
      document.title = title;

      $('body').print({
         title: title
      });
   }

   function checkcrc() { // used by save and print
      // if there is some change, adapt version
      globals2data();
      if (crc != data2crc()) {
         let today = date2iso(new Date());
         if (oldversiondate == today) {
            if (oldversionrev == versionrev) {
               versionrev++;
               oldversionrev = versionrev;
            }
         } else {
            versiondate = today;
            versionrev = 1;
            oldversiondate = versiondate;
         }
         //crc = data2crc();
      }
      $('#versiondate').text(versiondate);
      $('#versionrev').text(versionrev);
   }

   function jsonerror() {
      alert(_("Het gekozen bestand is niet bruikbaar.\n" +
         "Gebruik alleen bestanden die zijn gemaakt met dit programma."));
   }

   function handle_update_dates() { // needed for date picker
      startdate = $("#firstdate").val();
      enddate = $("#lastdate").val();
      etc2globals();
      quick_solution();
   }

   function createpops() {
      pop = [];
      meet = [];
      for (let i = 0; i < npop; i++) {
         pop[i] = [];
         foms[i] = 0;
         for (let j = 0; j < ndates; j++) {
            if (isfreeday[j]) {
               pop[i][j] = new Array(ndplayers).fill(-1);
            } else {
               pop[i][j] = randompoprow(avail[j], forces[j], vetos[j]);
            }
         }
      }
      for (let i = 0; i < nplayers; i++) {
         meet[i] = new Array(nplayers).fill(-1);
      }
   }

   function randompoprow(inp, f, v) { // row from avail, row from forces, row from vetos
      let row = [];
      for (let trie = 0; trie < 100; trie++) {
         let a = new Array(nplayers).fill(0);
         shuf(a);
         let k = -1;
         for (let j = 0; j < ndplayers; j++) {
            row[j] = -1;
         }
         for (let j = 0; j < nplayers; j++) {
            if (inp[a[j]] == 1 && !v[a[j]]) {
               k = k + 1;
               row[k] = a[j];
            }
            if (k == row.length - 1) {
               break;
            }
         }

         if (f.some(function(v) {
               return v != -1
            })) {
            let row1 = row.slice();
            row = f.slice();
            for (let j in row) {
               if (f[j] == -1 && row1[j] != -1) {
                  for (let k in row) {
                     if (!row.some(function(v) {
                           return v == row1[k]
                        })) {
                        row[j] = row1[k];
                        break;
                     }
                  }
               }
            }
         }

         let again = false;
         for (let j = 0; j < row.length - 1; j += 2) {
            // check if there is an avoids clash. If so, try again.
            // If not: return.
            // Also return if number of tries > 100
            let a1 = row[j];
            if (a1 < 0) break;
            let a2 = row[j + 1];
            if (a2 < 0) break;
            if (avoids[a1][a2]) {
               again = true;
               break;
            }
         }
         if (!again) break;
      }
      return row;
   }

   // return child of populations p and q
   function pair(p, q) {
      let r = [];
      let split = 1 + randint(p.length - 1); // take split rows from p 
      r = p.slice(0, split);
      r = r.concat(q.slice(split));
      return copydim2(r);
   }

   function fom(p) {
      fomevals++;
      makemeet(p);
      return weights[0] * playfom(p) + weights[1] * freefom(p) +
         weights[2] * evenfom(p) + weights[3] * meetfom() +
         weights[4] * gendfom();
   }

   function playfom(p) {
      const sums = new Array(nplayers).fill(0); // total number of games for each player
      for (let i = 0; i < p.length; i++) {
         if (isfreeday[i]) continue;
         for (let j = 0; j < p[0].length; j++) {
            let k = p[i][j]; // this is the index of the player
            if (k >= 0) { //    player is playing
               sums[k]++;
            }
         }
      }

      let ms = 0
      for (let i = 0; i < nplayers; i++)
         ms += sums[i];
      ms /= nplayers;

      let nnn = 10000;
      let w = new Array(nplayers)
      for (let i = 0; i < nplayers; i++) {
         // player does not participate in fom if
         // her number of plays is equal to the number of possibilities
         // AND the number of plays < ms
         w[i] = !(sumavail[i] == sums[i] && sums[i] < ms);
      }

      let meansum = 0;
      let nw = 0;
      for (let i = 0; i < nplayers; i++) {
         if (w[i]) {
            nw++;
            meansum += sums[i];
         }
      }
      if (nw == 0)
         return 0;
      meansum = meansum / nw;
      let pfom = 0;
      for (let i = 0; i < nplayers; i++) {
         if (w[i]) {
            pfom += Math.abs(sums[i] - meansum);
         }
      }
      return pfom;
   }

   function freefom(p) {
      const game = [];
      for (let i = 0; i < nplayers; i++) {
         maxfree[i] = 0; // this is a global
      }
      const free = new Array(nplayers).fill(0);

      for (let i = 0; i < p.length; i++) {
         if (isfreeday[i]) continue;
         for (let j = 0; j < nplayers; j++) {
            game[j] = 0;
         }
         for (let j = 0; j < ndplayers; j++) {
            let k = p[i][j];
            if (k < 0) continue;
            game[k] = 1
         }
         for (let j = 0; j < nplayers; j++) {
            if (avail[i][j] != 0 && game[j] == 0) {
               free[j] += 1;
            }
            if (game[j] == 1 || i == ndates - 1) {
               maxfree[j] = Math.max(maxfree[j], free[j]);
               free[j] = 0;
            }
         }
      }
      return maxval(maxfree);
   }

   function maxval(a) {
      let m = a[0];
      for (let i in a) {
         if (a[i] > m) m = a[i];
      }
      return m;
   }

   function evenfomrow4(r) {
      let s = [0, 0, 0, 0];

      let k = 0;
      let e = 0;

      do {
         let n = -1;
         for (let i = k; i < r.length; i++) {
            if (r[i] >= 0) {
               n++;
               s[n] = r[i];
               k++;
               if (n == 3) break;
            }
         }
         if (n < 3) return e;
         e += Math.abs(strength[s[0]] + strength[s[1]] -
            strength[s[2]] - strength[s[3]]);
      }
      while (true);
      return e;
   }

   function evenfomrow(r) {
      let e = 0;
      for (let i = 0; i < ndplayers; i += 4) {
         let rr = r.slice(i, i + 4);
         if (rr.length == 4) {
            e += evenfomrow4(rr);
         }
      }
      return e;
   }

   function evenfom(p) {
      if (maketeams == 0) return 0;
      let e = 0;
      for (let i = 0; i < p.length; i++) {
         if (isfreeday[i]) continue;
         e += evenfomrow(p[i]);
      }
      return e / p.length;
   }

   function meetfom() {
      let m = 0;
      for (let i = 0; i < meet.length; i++) {
         for (let j = i + 1; j < meet[0].length; j++) {
            m += (meet[i][j] - 1) * (meet[i][j] - 1);
         }
      }
      return m / meet.length;
   }

   function gendfom() {
      let g = 0;
      for (let i = 0; i < meet.length; i++) {
         for (let j = i + 1; j < meet[0].length; j++) {
            if (meet[i][j] > 0) {
               if (gender[j] == gender[i]) {
                  g += 1;
               }
            }
         }
      }
      return g / meet.length;
   }

   function makemeet(p) {
      meet = [];
      for (let i = 0; i < nplayers; i++) {
         meet[i] = new Array(nplayers).fill(0);
      }
      for (let i = 0; i < p.length; i++) {
         if (isfreeday[i]) continue;
         for (let j = 0; j < p[0].length - 1; j += 2) {
            let k = p[i][j];
            let L = p[i][j + 1];
            if (k >= 0 && L >= 0) {
               meet[k][L] += 1;
               meet[L][k] += 1;
            }
         }
      }
   }

   function print_avoids() {
      let h = [];
      for (let i = 0; i < nplayers; i++) {
         h[i] = i;
      }
      print('     ', formati(h, 3));
      for (let i = 0; i < nplayers; i++) {
         print(formati([i], 6) + formatb(avoids[i], 3, 'X', '.'));
      }
   }

   function print_foms(n) {
      print("Solution number ", n);
      prettyprintpop(pop[n]);
      makemeet(pop[n]);
      print("fom:    ", fom(pop[n]));
      print("playfom:", playfom(pop[n]), weights[0]);
      print("freefom:", freefom(pop[n]), weights[1]);
      print("evenfom:", evenfom(pop[n]), weights[2]);
      print("meetfom:", meetfom(), weights[3]);
      print("gendfom:", gendfom(), weights[4]);
      print("maxfree:");
      print(formati(maxfree, 3));
      print("meet:");
      let x = [];
      for (let i = 0; i < nplayers; i++) {
         x[i] = i;
      }
      print("   ", formati(x, 3));
      for (let i = 0; i < nplayers; i++) {
         print(formati([i], 3), formati(meet[i], 3));
      }
   }

   function prettyprintpop(p) {
      const x = [];
      for (let i = 0; i < nplayers; i++) {
         x[i] = i;
      }
      print('     ' + formati(x, 3));

      const sums = new Array(nplayers).fill(0);
      for (let i = 0; i < p.length; i++) {
         if (isfreeday[i]) {
            print("free");
            continue;
         }
         const c = new Array(nplayers).fill(ABSENTTXT);
         for (let j = 0; j < nplayers; j++) {
            if (avail[i][j] == 1) {
               c[j] = FREE;
            }
         }
         const teamof = new Array(nplayers).fill(' ');
         let t = 0;
         for (let j = 0; j < p[0].length; j++) {
            let k = p[i][j];
            if (k >= 0 && teamof[k] == ' ') {
               if (maketeams != 0)
                  teamof[k] = letters[t];
               else
                  teamof[k] = PLAYTXT;
               if (j % 2 == 1) {
                  t++;
               }
            }
         }
         for (let j = 0; j < p[0].length; j++) {
            let k = p[i][j];
            if (k >= 0) {
               c[k] = teamof[k];
               sums[k]++;
            }
         }

         let x = formati([i], 3) + '  ' + formati(c, 3) + "  ";
         for (let j = 0; j < p[0].length; j++) {
            if (j % 2 == 1) {
               x += " -";
            } else {
               x += "  ";
            }
            x += ("    " + p[i][j]).slice(-2);
         }
         print(x, evenfomrow(p[i]));
      }
      print('     ' + formati(sums, 3));
      print("");
   }

   function evoluate() {
      if (npop < 2) return;
      let numpairs = 50;
      let nummut = 2;
      let second = 0;
      let checkinterval = 200;
      let count = 0;
      let prevfomevals = fomevals;
      let prevfom = 1000000000;
      let time_start = Date.now();
      let max_time = 20 * 1000; // milliseconds
      let eps = 0.0001;
      const foms = new Array(npop);
      let gencomp = 0;
      for (let generation = 0; generation < ngen; generation++) {
         gencomp++;
         count++;
         if (count > checkinterval) {
            count = 0;
            for (let i = 0; i < npop; i++) {
               foms[i] = fom(pop[i]);
            }
            foms.sort(function(a, b) {
               return a - b;
            });

            let dfom;
            dfom = Math.abs(foms[0] - foms[Math.floor(foms.length / 2)]);
            dfom += Math.abs(foms[0] - prevfom);
            if (dfom <= eps) {
               break;
            }
            prevfom = foms[0];
            if (Date.now() - time_start > max_time) {
               break;
            }
         }

         for (let j = 0; j < numpairs; j++) {
            // choose two items to pair
            let first = randint(npop);
            while (true) {
               second = randint(npop);
               if (second != first) break;
            }
            const res = pair(pop[first], pop[second]);
            for (let k = 0; k < nummut; k++) { // mutate
               if (random() > 0.5) {
                  let krand = randint(ndates);
                  if (!isfreeday[krand]) {
                     res[krand] = randompoprow(avail[krand], forces[krand],
                        vetos[krand]);
                  }
               }
            }
            let f = fom(pop[first]);
            let s = fom(pop[second]);
            let r = fom(res);
            if (r >= f && r >= s) {
               // do nothing
            } else if (f < r && r < s) {
               pop[second] = copydim2(res);
            } else if (s < r && r < f) {
               pop[first] = copydim2(res);
            } else if (r < f && f < s) {
               pop[second] = copydim2(res);
            } else { // here: (r .lt. s .and. s .lt. f)
               pop[first] = copydim2(res);
            }
         }
      }
   }

   function compute_result() {
      fomevals = 0;
      print("start of compute_result:npop,ngen:", npop, ngen);
      print("ndates:       ", ndates);
      print("nplayers:     ", nplayers);
      print("ndplayers:    ", ndplayers);
      print("npop:         ", npop);
      print("ngen:         ", ngen);
      print("maketeams:    ", maketeams);
      print("strength:     ", strength);
      print("gender:       ", gender);
      print("weights:      ", weights);
      print("avail:        ", avail);
      print("avail.length: ", avail.length);
      print("avoids:       ");
      print_avoids();
      print("forces:");
      print_forces();
      print("vetos:");
      print_vetos();

      if (nplayers == 0)
         return;

      random.seed = fiddle;
      for (let i = 0; i < 100; i++)
         random();

      createpops();

      print("chromosome 0:", pop[0]);
      print("fom:", fom(pop[0]));
      print("playfom:", playfom(pop[0]));
      print("freefom:", freefom(pop[0]));
      print("evenfom:", evenfom(pop[0]));
      print("meetfom:", meetfom());
      print("gendfom:", gendfom());

      if (npop >= 5) {
         print("chromosome 4:", pop[4]);
         print("fom:", fom(pop[4]));
      }


      const foms = [];
      for (let i = 0; i < pop.length; i++) {
         foms[i] = fom(pop[i]);
      }
      const ind = [];
      sortWithIndices(foms, ind);

      if (npop >= 10) {
         print("First 10 foms:", foms.slice(0, 10));
         print("Last 10 foms:", foms.slice(-10));
      }
      print('best at start:');
      print_foms(ind[0]);

      if (npop > 4) {
         let res = pair(pop[3], pop[4]);
         print("--- 3");
         prettyprintpop(pop[3]);
         print("fom:", fom(pop[3]));
         print("--- 4");
         prettyprintpop(pop[4]);
         print("fom:", fom(pop[4]));
         print("--- res");
         prettyprintpop(res);
         print("fom:", fom(res));
      }

      print("=========evoluate");

      let t0 = Date.now();
      evoluate();
      print("evoluation time used:", (Date.now() - t0) / 1000, "sconds");

      foms.length = 0;
      for (let i = 0; i < npop; i++) {
         foms[i] = fom(pop[i]);
      }
      sortWithIndices(foms, ind);
      if (npop > 10) {
         print('best foms:', foms.slice(0, 10));
         print('');
         print('worst foms:', foms.slice(-10));
      }

      for (let i = 2; i >= 0; i--) {
         if (i == 0) {
            print("Best solution:");
         }
         if (i < npop) {
            print_foms(ind[i]);
         }
      }
      result = copydim2(pop[ind[0]]);
      need_apply = false;
      resultversion = VERSION;
      print("compute_result:fomevals:", fomevals);
   }

   function init_data() {
      let x = {
         "programid": programid,
         "version": {
            "date": "2024-01-01",
            "rev": 1
         },
         "persons": {
            "beckenbauer": {
               "absent": {
                  "2012-02-04": 1,
                  "2012-02-06": 1
               },
               "email": "hans@example.com",
               "phone": "06-999900",
               "name": "Hans B.",
            },
            "piet": {
               "email": "pietersma@casema.nl",
               "phone": "06-12345678",
               "absent": {
                  "2024-04-19": 1
               },
               "force": {
                  "2024-02-16": 0,
                  "2024-05-03": 1,
                  "2024-05-10": 2
               },
               "gender": 0,
               "name": "Piet Pietersma",
            },
            "carla": {
               "email": "carla@abc.com",
               "phone": "060-123456789",
               "absent": {
                  "2024-02-09": 1,
                  "2024-04-26": 1
               },
               "veto": {
                  "2024-02-23": 1,
                  "2000-02-03": 1
               },
               "strength": 3,
               "gender": 1,
               "name": "C. Mariskadottir",
            },
            "mies": {
               "email": "mies@example.com",
               "phone": "070-333777666",
               "absent": {
                  "2024-01-26": 1,
                  "2024-03-08": 1,
                  "2024-02-09": 1
               },
               "veto": {
                  "2024-05-24": 1
               },
               "avoid": {
                  "wim": 1,
                  "zus": 1
               },
               "gender": 1,
               "name": "Mies Muizenis",
            },
            "wim": {
               "email": "wc@example.com",
               "phone": "06-9876545678",
               "absent": {
                  "2024-02-09": 1,
                  "2024-03-29": 1
               },
               "force": {
                  "2024-03-15": 1,
                  "2000-03-09": 0
               },
               "strength": 1,
               "name": "Wim Carlsson",
            },
            "zus": {
               "email": "zschaafsma2@trala.com",
               "phone": "08-890",
               "absent": {
                  "2024-01-05": 1,
                  "2024-01-12": 1,
                  "2024-01-19": 1,
                  "2024-01-26": 1,
                  "2024-02-02": 1,
                  "2024-02-09": 1,
                  "2024-02-16": 1,
                  "2024-02-23": 1,
                  "2024-03-01": 1,
                  "2024-03-08": 1,
                  "2024-03-22": 1,
                  "2024-03-29": 1,
                  "2024-04-05": 1,
                  "2024-04-12": 1,
               },
               "name": "Z. Schaafsma",
               "gender": 1,
            },
            "jet": {
               "email": "kamervraag@gmail.com",
               "phone": "geen telefoon",
               "absent": {
                  "2024-02-09": 1
               },
               "name": "Jet Kamervraag",
               "gender": 1,
            },
            "": {
               "email": "",
               "phone": "",
               "absent": {},
            },
            "jongejan": {
               "email": "piet@example.com",
               "phone": "o70-piet",
               "absent": {},
               "name": "piet jongejan-staas",
            },
            "pietersma": {
               "email": "jan@example.com",
               "phone": "06-jan",
               "absent": {},
               "name": "jan pietersma ",
            },
            "trijntje": {
               "email": "oo@example.com",
               "phone": "06-trijntje",
               "absent": {},
               "name": "T. Oosterhuis",
               "gender": 1,
            },
            "pieter": {
               "email": "kamgaren@example.com",
               "phone": "0800-12345",
               "absent": {},
               "name": "Pieter Kamgaren",
            }
         },
         "players": [
            "Piet",
            "Carla",
            "Mies",
            "Wim",
            "Zus",
            "Jet"
         ],
         "rplayers": [
            "Trijntje",
            "Pieter"
         ],
         "freedays": {
            "2024-03-15": 1
         },
         "startdate": "2024-01-05",
         "gametype": "",
         "ndates": 21,
         "ndplayers": "4",
         "daypayers": "1",
         "fiddle": "1",
         "maketeams": 1,
         "varia": "Locatie: OLTC Tijd: 10:00-11:00\n\nLet op: wie het rondje betaalt, wordt ook geacht de baan te reserveren.",
      }
      return x;
   }

   function apply_warning() {
      let t = "";
      t += '<div class="applywarningwrapper noprint">\n';
      t += '   <div class="applywarning apply noprint">\n';
      t += '   </div>\n';
      t += '</div>\n';
      return t;
   }

   function init_table() {
      let t = '';

      t += '<a id="schemejump"></a>\n';

      //t += apply_warning();

      t += '<div id="directionswrapper" class="noprint">';
      t += '   <div id="directions">';
      t += '      <b>' + _("Aanpassen wel/niet spelen datum: klik op datum in het schema") + '.</b>\n';
      t += '      <br>';
      t += '      <b>' + _("Aanpassen status speler: klik onder de naam in het schema") + '.</b>\n';
      t += '   </div>';
      t += '</div>';

      t += '<table id="table" class="mf-region">\n';
      t += '   <thead>\n';
      t += '      <tr id="tableheader">\n';
      t += '         <th>xxx</th>\n';
      t += '      </tr>\n';
      t += '   </thead>\n';
      t += '   <tbody id="tablebody">\n';
      t += '      <tr id="firstrow"><td>startdatum </td></tr>\n';
      t += '   </tbody>\n';
      t += '   <tfoot id="tablefooter">\n';
      t += '      <tr id="sumplayrow"><td class="sums noinput">' + _("Te spelen") + ':</td></tr>\n';
      t += '      <tr id="sumpayrow"><td class="noinput">' + _("Drankjes") + ':</td></tr>\n';
      t += '   </tfoot>\n';
      t += '</table>\n';

      t += '<a id="reservejump"></a>\n';
      t += '<br>\n';
      t += '<table id="reserve">\n';
      t += '   <thead>\n';
      t += '      <tr id="reserveinput">\n';
      t += '         <th>reserve</th>\n'
      t += plusrplayerth;
      t += '      </tr>\n';
      t += '   </thead>\n';
      t += '   <tbody style="display:none;">\n';
      t += '      <tr><td> </td></tr>\n';
      t += '   </tbody>\n';
      t += '</table>\n';

      if (nrplayers + nplayers != 0) {
         t += '<a id="emailsjump"></a>\n';
         t += '<br>\n';
         t += '<table id="emails" class="mf-region">\n';
         t += '   <thead id="emailheader" class="noinput">\n';
         t += '      <tr>\n';
         t += '         <th>&nbsp;' + _("Speler") + '&nbsp;</th>\n';
         t += '         <th align="center">&nbsp;' + _("Naam") + '&nbsp;</th>\n';
         t += '         <th align="center">&nbsp;' + _("E-mail") + '&nbsp;</th>\n';
         t += '         <th align="center">&nbsp;' + _("Telefoon") + '&nbsp;</th>\n';
         t += '         <th align="center" class="noprint">&nbsp;' + _("Sterkte") + '&nbsp;</th>\n';
         t += '         <th align="center" class="noprint">&nbsp;' + _("M/V") + '&nbsp;</th>\n';
         t += '      </tr>\n';
         t += '   </thead>\n';
         t += '   <tbody id="emailbody">\n';
         t += '   </tbody>\n';
         t += '   <tfoot id="emailfooter">\n';
         t += '   </tfoot>\n';
         t += '</table>\n';
      }

      t +=
         '<a id="variajump"></a>\n' +
         '<br>\n' +
         '<table id="tvaria">\n' +
         '   <tr><td class="has-input">\n' +
         '   <textarea id="varia" placeholder="' + _("Vul hier additionele gegevens zoals plaats en tijd in") + '.">\n' +
         '   </textarea>\n' +
         '   </td></tr>\n' +
         '</table>\n' +
         '<br>\n';

      t +=
         '<div id="avoids" class="noprint" style="text-align:center">\n' +
         '   <table id="avoidstable">\n' +
         '      <tr><td>\n' +
         '          <span id="avoidshead">&nbsp;' + _("Spelers die liever niet in hetzelfde team zitten") + '.&nbsp;</span>\n' +
         '          <br>\n' +
         '          <span>&nbsp;' + _("Beweeg de muis over een naam om uw keuze te maken") + '.&nbsp;</span>\n' +
         '      </td></tr>\n' +
         '   </table>\n' +
         '</div>\n';

      t += '<div id="copyright" class="noprint">\n';
      t += '&copy;&nbsp;2024 Willem Vermin, Carla Vermin&nbsp;';
      t += '</div>\n';
      //t += apply_warning();
      t += '<div class="noprint" class="filler">\n'
      for (let i = 0; i < 10; i++) {
         t += '<br><br><br><br><br>';
         t += '\n';
      }

      t += '</div>\n';

      return t;
   }


   function makelink(link, desc) {
      return '<span onclick="goto(\'' + link + '\')" class="link">' + desc + '</span>\n';
   }

   function init_help() {
      let t = '';
      t += '<div id="helptext">\n';
      t += '   <button id="leavemenubutton">&nbsp;' + _("Terug naar schema") + '&nbsp;</button>\n';
      t += '   <button id="totopbutton">&nbsp;' + _("Terug naar top") + '&nbsp;</button>\n';
      t += '   <br>\n';
      t += '   <h2>' + _("Handleiding") + '</h2>\n';

      t += '   <ul>\n';
      t += '      <li>' + _("Als voorbeeld wordt als sport tennis gekozen, maar u kunt ook een andere sport instellen") + '</li>\n';
      t += '   </ul>\n';

      t += '   <b>' + _("Met dit programma stelt u een wekelijks tennisschema samen: Wie speelt wanneer in welk team") + '.</b>\n';

      t += '   <ul>\n';
      t += '      <li>' + makelink("beschrijving", _("beschrijving van het programma")) + '\n';
      t += '      <li>' + makelink("bediening", _("stappenplan: volgorde invoer (in het kort)")) + '\n';
      t += '      <li>' + makelink("beschrijvingplus", _("beschrijving alle opties")) + '\n';
      t += '   </ul>\n';
      t += '   <hr>\n'
      t += '   <h3>' + '<a id="beschrijving">' + _("Beschrijving van het programma") + '</h3>' + '</a>\n';
      t += '   <ul>';
      t += '      <li>' + _("U bepaalt welke spelers meedoen, hoeveel spelers er op een dag spelen en wie het drankje betaalt") + '.</li>\n';
      t += '      <li>' + _("U stelt verhinderdata per persoon in en algehele verhinderdata (Kerstmis bijvoorbeeld)") + '.</li>\n';
      t += '      <li>' + _("U kunt voorkomen dat bepaalde spelers niet in hetzelfde team uitkomen") + '.</li>\n';
      t += '      <li>' + _("U voert de e-mail adressen, telefoonnummers, volledige namen, sterkte en geslacht van de spelers en reservespelers in") + '.</li>\n';
      t += '      <li>' + _("Er is ruimte voor vrije opmerkingen: locatie en dergelijke") + '.</li>\n';
      t += '      <li>' + _("Het programma stelt automatisch het schema samen. Er wordt <b>automatisch</b> voor gezorgd dat zoveel mogelijk") + ':</li>\n';
      t += '      <ul>'
      t += '         <li>' + _("alle spelers een gelijk aantal speel- en koffiebeurten hebben") + ',</li>\n';
      t += '         <li>' + _("de teams in evenwicht zijn qua sterkte") + ',</li>\n';
      t += '         <li>' + _("de teams steeds verschillend worden samengesteld") + ',</li>\n';
      t += '         <li>' + _("de teams bestaan uit een mix van man en vrouw") + '.</li>\n';
      t += '         <li>' + _("het aantal opeenvolgende vrije dagen voor een speler wordt geminimaliseerd") + '.</li>\n';
      t += '      </ul>\n';
      t += '      <li>' + _("U kunt forceren dat een speler op een bepaalde dag speelt, of juist niet speelt") + '.</li>\n';
      t += '      <li>' + _("U kunt specificeren of het programma teams moet vormen of niet") + '.</li>\n';
      t += '      <li>' + _("De gegevens kunnen worden opgeslagen op uw eigen PC en later weer worden opgehaald") + '.</li>\n';
      t += '      <li>' + _("Het samengestelde schema kan worden ge&euml;exporteerd naar een pdf bestand dat u naar de deelnemende spelers kunt e-mailen") + '.</li>\n';
      t += '   </ul>\n';
      t += '   <h3>' + '<a id="bediening">' + _("Bediening van het programma") + '</h3>' + '</a>\n';


      t += '   ' + _("De te nemen stappen (in het kort) bij de <b> start van een leeg schema </b>") + '.\n';

      t += '   <ol>\n';
      t += '	  <li>' + _("Bekijk het voorbeeld via de knop {example} (optioneel)").fmt({
         "example": example_text,
      }) + '.' + "&#10140;" + makelink("voorbeeld", "&nbsp;&#9432;") + '</li>\n';
      t += '	      ' + _("Bij de tabel <b>{fill_in}</b>").fmt({
         "fill_in": fill_in_schedule,
      }) + '<b>:</b>\n';
      t += '      <li>' + _("Voer de naam van de sport in") + "&#10140;" + makelink("sport", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Voer startdatum en speeldagen in") + '. ' + "&#10140;" + makelink("startdatum", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Voer einddatum in") + '. ' + "&#10140;" + makelink("speeldatabij", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Bepaal maximum aantal spelers per dag") + '. ' + "&#10140;" + makelink("aantalspelers", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Bepaal of er teams moeten worden gevormd") + '. ' + "&#10140;" + makelink("team", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Geef aan hoeveel drankjes er per dag moeten worden betaald") + '. ' + "&#10140;" + makelink("drankjes", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Lees de legenda en ga spelers toevoegen. Een voornaam is voldoende") + '. ' + "&#10140;" + makelink("spelerbij", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Voeg reservespelers toe (optioneel)") + '. ' + "&#10140;" + makelink("reservespelerbij", "&nbsp;&#9432;;") + '</li>\n';
      t += '	  <li>' + _("Vul in het namenoverzicht de volledige gegevens in (naam, e-mail, etc.) (optioneel)") + '. ' + "&#10140;" + makelink("gegevensspeler", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Vul additionele gegevens in zoals bv. locatie en tijd (optioneel)") + '. ' + "&#10140;" + makelink("extrainfo", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Geef aan welke spelers liever niet samen in een team zitten (optioneel)") + '. ' + "&#10140;" + makelink("nietzelfdeteam", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Verwerk de ingevoerde gegevens (indien de oranje knop zichtbaar is)") + '. ' + "&#10140;" + makelink("verwerken", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Bewaar het schema") + '. ' + "&#10140;" + makelink("bewaren", "&nbsp;&#9432;") + '</li>\n';
      t += '	  <li>' + _("Bewaar als pdf of print") + '. ' + "&#10140;" + makelink("print", "&nbsp;&#9432;") + '</li>\n';
      t += '   </ol>\n';

      t += '   <h3>' + '<a id="beschrijvingplus">' + _("Beschrijving van alle opties") + '</h3>' + '</a>\n';

      t += '   <ul>\n';
      t += '   <li> <span class="firstli">' + _("Algemeen") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Het programma start met een leeg speelschema") + '.</li>\n';
      t += '         <li>' + _("Hierin vult u spelers, startdatum, einddatum en speeldagen in") + '.</li>\n';
      t += '         <li>' + _("Alle velden in het schema zijn aanklikbaar om verhinderdagen aan te geven, of om te forceren dat een speler uitkomt in een team of niet speelt") + '.</li>\n';


      t += '         <a id="voorbeeld"></a>\n'
      t += '         <br>\n';
      t += '      </ul>\n';
      t += '   </li>\n';
      t += '   <li> <span class="firstli">' + _("Voorbeeld") + '</span>' + '<i>' + _(" (stap 1 - optioneel)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de <b>{example}</b> knop om een voorbeeld schema te zien").fmt({
         example: example_text
      }) + '.        </li>\n';
      t += '         <li>' + _("Hiermee kun U oefenen of het schema eventueel aanpassen met uw eigen gegevens") + '. </li>\n';
      t += '         <li>' + _("Klik op <b>{new_schedule}</b> om een leeg schema te maken").fmt({
         "new_schedule": new_schedule_text,
      }) + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="sport"></a>\n';
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Naam van de sport instellen") + '</span>' + '<i>' + _(" (stap 2)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Vul de gewenste naam van de sport in op het veld achter <b>{sport}</b>").fmt({
         "sport": game_text
      });
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="startdatum"></a>\n';
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Startdatum en speeldagen instellen") + '</span>' + '<i>' + _(" (stap 3)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op het veld achter <b>{startdate}</b> en kies de gewenste startdatum met de kalender-pop-up").fmt({
         "startdate": start_date_text,
      }) + '. </li>\n';
      t += '         <li>' + _("Eindig de kalender-pop-up door op <b>X</b> te klikken, rechtsboven in de kalender") + '. </li>\n';
      t += '         <li>' + _("Desgewenst kunt u ook extra speeldagen instellen: klik op een of meer dagen achter de startdatum") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="speeldatabij"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Einddatum vastleggen") + '</span>' + '<i>' + _(" (stap 4)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op het veld achter <b>{enddate}</b> en kies de gewenste einddatum met de kalender-pop-up").fmt({
         "enddate": last_date_text,
      }) + '. </li>\n';
      t += '         <li>' + _("Eindig de kalender-pop-up door op <b>X</b> te klikken, rechtsboven in de kalender") + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="aantalspelers">' + '</a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Aantal spelers per dag instellen") + '</span>' + '<i>' + _(" (stap 5)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Stel het aantal spelers per dag in met de knop achter <b>{maxplayers}</b>").fmt({
         "maxplayers": players_max_day_text,
      }) + '. </li>\n';
      t += '     </ul>\n';
      t += '   </li>\n';


      t += '   <a id="team"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Teams of geen teams") + '</span>' + '<i>' + _(" (stap 6)") + '</i>\n';
      t += '      <ul>';
      t += '         <li>' + _("Met de knop <b>{teams}</b> stelt u in of het programma teams moet samenstellen (<i>{yes}</i>) of niet (<i>{no}</i>)").fmt({
         teams: teams_text,
         yes: yes_text,
         no: no_text
      }) + '.       </li>\n';
      t += '     </ul>\n';
      t += '   </li>\n';

      t += '   <a id="drankjes">' + '</a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Aantal drankjes-betalers per dag instellen") + '</span>' + '<i>' + _(" (stap 7)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Stel het aantal drankjes-betalers per dag in met <b>{drinks}</b>").fmt({
         drinks: drinks_per_day_text
      }) + '.        </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="spelerbij"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Toevoegen speler") + '</span>' + '<i>' + _(" (stap 8)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de knop <b>{Add}</b> achter <b>{Add_players}</b>").fmt({
         "Add": add_text,
         "Add_players": add_players_text,
      }) + '.</li>\n';
      t += '         <li>' + _("Of:") + '&nbsp;' + _("Klik op de knop <b>{Add_player}</b> achter de namen in het schema en vul een (voor)naam in").fmt({
         "Add_player": add_player_text,
      }) + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';
      t += '   <li><span class="firstli">' + _("Verwijderen speler") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op") + ' <span class="fat"><span class="fatbig">-</span></span>' + _(" achter de naam van een speler") + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="reservespelerbij"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Toevoegen reservespeler") + '</span>' + '<i>' + _(" (stap 9)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de knop <b>{Add}</b> achter <b>{Add_rplayer}</b>").fmt({
         "Add": add_text,
         "Add_rplayer": add_rplayer_text,
      }) + '.</li>\n';
      t += '         <li>' + _("Of:") + '&nbsp;' + _("In de tabel <b>{Reserve}</b>, klik op").fmt({
         Reserve: reserve_player_text
      });
      t += '             <b>' + _(add_rplayer_text) + ' </b>' + _("en vul de (voor)naam van de reservespeler in") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';
      t += '   <li><span class="firstli">' + _("Verwijderen reservespeler") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op") + ' <span class="fat"><span class="fatbig">-</span> </span>' + _("achter de te verwijderen reservespeler") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Veranderen naam van speler of reservespeler") + '</span></li>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de betreffende naam en verander hem.  Let op: meestal leidt dit tot de aanmaak van een nieuwe speler. U heeft immers de naam veranderd") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="verhinder"></a>\n'
      t += '   <br>';
      t += '   <li><span class="firstli">' + _("Instellen verhinderdag of forceer team of uitval") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Ga naar de rij met de betreffende datum en klik in de kolom onder de naam van de betreffende speler") + '. ';
      t += '            ' + _("Er verschijnt een keuzemenu") + '.</li>\n';
      t += '         <li>' + _("Klik op wat van toepassing is") + '. ' + _("Kies") + ' <i>' + _("standaard") + '</i> ' + _("als het programma het mag bepalen") + '.';
      t += '            ' + _("De cel wordt roze als U bepaalt wat er gebeurt, en niet het programma") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="datumgeentennis"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Instellen/verwijderen datum waarop niet kan worden gespeeld (bv. Kerstmis)") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik links in de tabel op de gewenste datum: de rij kleurt groen") + '. </li>\n';
      t += '         <li>' + _("Door nogmaals op die datum klikken wordt de wijziging ongedaan gemaakt") + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="gegevensspeler"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Gegevens van spelers") + '</span>' + '<i>' + _(" (stap 10)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op <b>{name_etc}</b>").fmt({
         "name_etc": naw_text
      }) + '.</li>\n';
      t += '         <li>' + _("Naam, e-mail en telefoon van de spelers vult u in in de tabel onder het schema") + '.</li>\n';
      t += '         <li>' + _("Desgewenst kan worden aangegeven wat de sterkte en geslacht van de speler is: beweeg de muis over het betreffende veld en stel de gewenste waarde in") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="extrainfo"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Extra informatie toevoegen") + '</span>' + '<i>' + _(" (stap 11 - optioneel)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op <b>{varia}</b>").fmt({
         "varia": varia_text
      }) + '.</li>\n';
      t += '         <li>' + _("Onder de tabel met de gegevens van de spelers is een veld waarin u willekeurige gegevens kunt intypen, zoals plaats, tijd, locatie") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="nietzelfdeteam"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Spelers niet in hetzelfde team") + '</span>' + '<i>' + _(" (stap 12 - optioneel)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Onder het kopje") + ' <i>' + _("Spelers die liever niet in hetzelfde team zitten") + '</i> ' +
         '              ' + _("staat een rij met de namen van de spelers") + '.</li>\n';
      t += '         <li>' + _("Als U bijvoorbeeld wilt verhinderen dat Carla en Jet in hetzelfde team worden geplaatst: hover over Carla en klik Jet") + '. </li>\n';
      t += '         <li>' + _("Carla en Jet zullen nu niet meer in hetzelfde team worden geplaatst") + '.</li>\n';
      t += '         <li>' + _("Door nogmaals te klikken wordt de beperking weer opgeheven") + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="verwerken"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Verwerk uw gegevens") + '</span>' + '<i>' + _(" (stap 13)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Om het effect te zien van uw input: klik op de oranje knop <b>{Process}</b> om het resultaat van het bijgewerkte schema te zien").fmt({
         "Process": process_text,
      }) + '.</li>\n';
      t += '         <li>' + _("De knop wordt grijs wanneer de gegevens zijn verwerkt") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <a id="bewaren"></a>\n'
      t += '   <br>\n';
      t += '   <li><span class="firstli">' + _("Bewaren van de gegevens van het ingevulde schema") + '</span>' + '<i>' + _(" (stap 14)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de knop") + ' <b>' + store_text + '.</b></li>\n';
      t += '         <li>' + _("Afhankelijk van de browser die u gebruikt (Firefox, Edge, Chrome...) wordt het bestand direct opgeslagen of wordt een scherm gepresenteerd waarin u de naam van het bestand en directory kunt aangeven") + '.</li>\n';
      t += '         <li>' + _("Als suggestie wordt een naam gegeven met daarin datum en dergelijke van het schema") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <br>\n';


      t += '   <a id="print"></a>\n';
      t += '   <li><span class="firstli">' + _("Bewaren als pdf of printen") + '</span>' + '<i>' + _(" (stap 15)") + '</i>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de knop") + ' <b>' + print_pdf_text + '</b>.</li>\n';
      t += '         <li>' + _("De browser (Firefox, Edge, Chrome...) presenteert een scherm waarin u de keuze maakt tussen printen en bewaren als pdf") + '. </li>\n';
      t += '         <li>' + _("Tevens wordt een voorbeeld getoond hoe een en ander er uit gaat zien") + '. </li>\n';
      t += '         <li>' + _("Dit voorbeeld moet u niet te letterlijk nemen, soms zijn bv. enkele horizontale lijnen weggevallen") + '.</li>\n';
      t += '         <li>' + _("Wel kunt u hier, indien nodig, de grootte van de pagina aanpassen middels de opties <i>fit to page</i>, <i>scale in %</i>, of iets dergelijks of kiezen voor Portrait of Landscape (staand of liggend)") + '. ';
      t += '                ' + _("De preciese opties zijn afhankelijk van de gebruikte browser en/of printer") + '.\n';
      t += '         <li>' + _("Het pdf bestand kunt u als bijlage e-mailen naar de spelers") + '. ';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <br>';

      t += '   <li><span class="firstli">' + _("Ophalen van bewaarde gegevens") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik op de knop") + ' <b>' + open_text + '.</b></li>\n';
      t += '         <li>' + _("De browser (Firefox, Edge, Chrome...) presenteert dan een scherm waarin u het gewenste, voorheen bewaarde schema, kunt selecteren, openen en veranderen") + '.</li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';

      t += '   <br>\n';

      t += '   <li><span class="firstli">' + _("Handleiding") + '</span>\n';
      t += '      <ul>\n';
      t += '         <li>' + _("Klik de knop") + ' <b>' + _("Handleiding") + ' / ' + _("stappenplan") + '</b></li>\n';
      t += '         <li>' + _("Keer terug naar het schema door op de knop <b>{back}</b> te klikken").fmt({
         "back": _("Terug naar schema"),
      }) + '. </li>\n';
      t += '      </ul>\n';
      t += '   </li>\n';
      t += '   </ul>\n';
      t += '   <div class="noprint">\n';
      t += '      <br><br><br><br><br><br><br><br><br><br>\n<br><br><br><br><br><br><br><br><br><br><br><br><br><br>\n';
      t += '      <br><br><br><br><br><br><br><br><br><br>\n<br><br><br><br><br><br><br><br><br><br><br><br><br><br>\n';
      t += '   </div>\n';
      t += '</div>'; // id=helptext
      return t;
   }

});
